PRINT '### Version 1.46 ###'
-- --------- Zmiana wersji na koncu! --------------
GO

GO
if (SELECT Count(*) FROM master.dbo.sysdatabases WHERE name='Magnat')=0
begin
	PRINT '### Creating Database Magnat ###'
	CREATE DATABASE Magnat COLLATE Polish_CI_AS
end
else
	PRINT '### Upgrading Database Magnat ###'
	-- ALTER DATABASE Magnat COLLATE Polish_CI_AS
	
GO
USE Magnat
GO






PRINT '### Opcje ###'
GO

IF (OBJECT_ID('Opcje') IS NULL)
CREATE TABLE [Opcje] (
	[nazwa] [nvarchar] (50) NOT NULL ,
	[wartosc] [nvarchar] (255) NULL ,
) ON [PRIMARY]
GO

PRINT '### Version stored procedure ###'
GO

IF (OBJECT_ID('GetBaseVersion') IS NULL) EXEC ('CREATE PROCEDURE GetBaseVersion AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE GetBaseVersion (@BaseVersion float(24) OUTPUT)
AS
BEGIN
	SELECT @BaseVersion=wartosc FROM Opcje WHERE nazwa='BaseVersion'
	set @BaseVersion=IsNull(@BaseVersion,0)
END
GO

IF (OBJECT_ID('SetBaseVersion') IS NULL) EXEC ('CREATE PROCEDURE SetBaseVersion AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE SetBaseVersion (@BaseVersion float(24))
AS
BEGIN
	DELETE FROM Opcje WHERE nazwa='BaseVersion'
	INSERT Opcje (nazwa,wartosc) VALUES ('BaseVersion', @BaseVersion )
END
GO

DECLARE @BaseVersion float(24) Execute GetBaseVersion @BaseVersion OUTPUT
if @BaseVersion>0 PRINT '### Current Database Version: ' + CAST(@BaseVersion AS varchar) + ' ###'
-- if @BaseVersion>=1.06 PRINT '### This Version is already installed ###'
GO



--PRINT '### set autoshirnk option ###'
--GO
--IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.13)=0
--BEGIN
--EXEC sp_dboption 'Magnat', 'autoshrink', 'TRUE'
--END
--GO




PRINT '### Uzytkownicy ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE TABLE [Uzytkownicy] (
	[uzytkownikID] [int] IDENTITY (1, 1) NOT NULL ,
	[kod] [nvarchar] (50) NOT NULL ,
	[nazwa] [nvarchar] (50) NOT NULL ,
	[haslo] [nvarchar] (50) NOT NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Uzytkownicy] WITH NOCHECK ADD 
	CONSTRAINT [DF_Uzytkownicy_haslo] DEFAULT ('') FOR [haslo],
	CONSTRAINT [PK_Uzytkownicy] PRIMARY KEY  NONCLUSTERED 
	(
		[uzytkownikID]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_Uzytkownicy] UNIQUE  NONCLUSTERED 
	(
		[kod]
	)  ON [PRIMARY] 
GO
-- V 1.22
-- Dodano pole pin
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.22)=0
ALTER TABLE Uzytkownicy ADD pin [nvarchar](50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.22)=0
 CREATE  INDEX [IX_Uzytkownicy_1] ON [Uzytkownicy](pin)
GO
-- V 1.39
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.39)=0
 ALTER TABLE Uzytkownicy ADD aktywny int NOT NULL DEFAULT 1
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.39)=0
 CREATE  INDEX [IX_Uzytkownicy_2] ON [Uzytkownicy](aktywny)
GO



PRINT '### Opcje (c.d.) ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Opcje] ADD
	[uzytkownikID] [int] NULL
GO

--IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
--ALTER TABLE [Opcje] WITH NOCHECK ADD 
--	CONSTRAINT [PK_Opcje] PRIMARY KEY  NONCLUSTERED 
--	(
--		[nazwa],
--		[uzytkownikID]
--	)  ON [PRIMARY] 
--GO

IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Opcje] ADD 
	CONSTRAINT [FK_Opcje_Uzytkownicy] FOREIGN KEY 
	(
		[uzytkownikID]
	) REFERENCES [Uzytkownicy] (
		[uzytkownikID]
	)
GO

-- V 1.01
-- opcje.uzytkownik moze byc NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
begin
IF (OBJECT_ID('PK_Opcje') IS NOT NULL)
	ALTER TABLE [Opcje] DROP CONSTRAINT PK_Opcje
end
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE Opcje
	ALTER COLUMN
	[uzytkownikID] [int] NULL 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Opcje_1] ON [Opcje]([nazwa]) ON [PRIMARY]
GO

IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.39)=0
begin
	ALTER TABLE Opcje DROP CONSTRAINT FK_Opcje_Uzytkownicy
	ALTER TABLE Opcje WITH NOCHECK ADD CONSTRAINT FK_Opcje_Uzytkownicy FOREIGN KEY (uzytkownikID) REFERENCES Uzytkownicy(uzytkownikID) ON UPDATE CASCADE ON DELETE CASCADE
end
GO







PRINT '### Firmy ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE TABLE [Firmy] (
	[firmaID] [int] IDENTITY (1, 1) NOT NULL ,
	[kod] [nvarchar] (100) NOT NULL ,
	[nazwa] [nvarchar] (255) NOT NULL ,
	[adres] [nvarchar] (255) NULL ,
	[nip] [nvarchar] (50) NULL ,
	[regon] [nvarchar] (50) NULL ,
	[bank] [nvarchar] (50) NULL ,
	[konto] [nvarchar] (50) NULL ,
	[telefon] [nvarchar] (50) NULL ,
	[fax] [nvarchar] (50) NULL ,
	[email] [nvarchar] (50) NULL ,
	[opis] [nvarchar] (255) NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Firmy] WITH NOCHECK ADD 
	CONSTRAINT [PK_Firmy] PRIMARY KEY  NONCLUSTERED 
	(
		[firmaID]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_firma] UNIQUE  NONCLUSTERED 
	(
		[kod]
	)  ON [PRIMARY] 
GO
-- V 1.34
-- dodano znacznik 'domyslna'
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
ALTER TABLE Firmy ADD domyslna [int] NULL DEFAULT 0
GO

-- V 1.34
-- dodano Przynaleznoci
PRINT '### Przynaleznosci ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
CREATE TABLE [Przynaleznosci] (
	[przynaleznoscID] [int] IDENTITY (1, 1) NOT NULL ,
	[firmaID] [int] NOT NULL ,
	[uzytkownikID] [int] NOT NULL ,
	[firma_domyslna] [int] NOT NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
ALTER TABLE [Przynaleznosci] WITH NOCHECK ADD 
	CONSTRAINT [PK_Przynaleznosci] PRIMARY KEY  NONCLUSTERED 
	(
		[przynaleznoscID]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_Przynaleznosci] UNIQUE  NONCLUSTERED 
	(
		[uzytkownikID], [firmaID]
	)  ON [PRIMARY] ,
	CONSTRAINT [DF_Przynaleznosci_typ] DEFAULT (0) FOR [firma_domyslna]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
 CREATE  INDEX [IX_Przynaleznosci_1] ON [Przynaleznosci]([uzytkownikID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
 CREATE  INDEX [IX_Przynaleznosci_2] ON [Przynaleznosci]([firmaID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
 CREATE  INDEX [IX_Przynaleznosci_3] ON [Przynaleznosci]([uzytkownikID],[firma_domyslna]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
	INSERT INTO Przynaleznosci (firmaID, uzytkownikID, firma_domyslna)
		SELECT firmaID, uzytkownikID, 1 as firma_domyslna FROM Uzytkownicy, Firmy
GO

PRINT '### Kontrahenci ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE TABLE [Kontrahenci] (
	[kontrahentID] [int] IDENTITY (1, 1) NOT NULL ,
	[kod] [nvarchar] (100) NOT NULL ,
	[nazwa] [nvarchar] (255) NOT NULL ,
	[adres] [nvarchar] (255) NULL ,
	[nip] [nvarchar] (50) NULL ,
	[regon] [nvarchar] (50) NULL ,
	[bank] [nvarchar] (50) NULL ,
	[konto] [nvarchar] (50) NULL ,
	[telefon] [nvarchar] (50) NULL ,
	[fax] [nvarchar] (50) NULL ,
	[email] [nvarchar] (50) NULL ,
	[opis] [nvarchar] (255) NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Kontrahenci] WITH NOCHECK ADD 
	CONSTRAINT [PK_Kontrahenci] PRIMARY KEY  NONCLUSTERED 
	(
		[kontrahentID]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_Kontrahenci] UNIQUE  NONCLUSTERED 
	(
		[kod]
	)  ON [PRIMARY] 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Kontrahenci_1] ON [Kontrahenci]([nip]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Kontrahenci_2] ON [Kontrahenci]([regon]) ON [PRIMARY]
GO
-- V 1.26
-- dodano Kod2
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.26)=0
ALTER TABLE Kontrahenci ADD kod2 [nvarchar] (100) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.26)=0
 CREATE  INDEX [IX_Kontrahenci_3] ON [Kontrahenci](kod2)
GO
-- V 1.40
-- Dodano pole data i uytkownik tworz
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.40)=0
ALTER TABLE Kontrahenci ADD uzytkownik_tworzID int NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.40)=0
ALTER TABLE Kontrahenci ADD CONSTRAINT FK_Kontrahenci_Uzytkownicy1 FOREIGN KEY 
	(uzytkownik_tworzID) REFERENCES Uzytkownicy(uzytkownikID)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.40)=0
ALTER TABLE Kontrahenci ADD data_tworz [smalldatetime] NULL
GO
-- V 1.40
-- Dodano pole data i uytkownik modyf
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.40)=0
ALTER TABLE Kontrahenci ADD uzytkownik_modyfID int NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.40)=0
ALTER TABLE Kontrahenci ADD CONSTRAINT FK_Kontrahenci_Uzytkownicy2 FOREIGN KEY 
	(uzytkownik_modyfID) REFERENCES Uzytkownicy(uzytkownikID)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.40)=0
ALTER TABLE Kontrahenci ADD data_modyf [smalldatetime] NULL
GO

-- V 1.41
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.41)=0
ALTER TABLE [Kontrahenci] ALTER COLUMN [data_tworz] [datetime]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.41)=0
ALTER TABLE [Kontrahenci] ALTER COLUMN [data_modyf] [datetime]
GO


PRINT '### Towary ###'
GO


IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE TABLE [Towary] (
	[towarID] [int] IDENTITY (1, 1) NOT NULL ,
	[kod] [nvarchar] (100) NOT NULL ,
	[nazwa] [nvarchar] (255) NOT NULL ,
	[pn] [nvarchar] (50) NULL ,
	[kategoria] [nvarchar] (80) NULL ,
	[gwarancja_wzorcowa] [int] NULL ,
	[opis] [nvarchar] (255) NULL ,
	[typ_gwarancji_wzorcowej] [nvarchar] (50) NOT NULL ,
	[stan_minimalny] [int] NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Towary] WITH NOCHECK ADD 
	CONSTRAINT [DF_Towary_typ_gwarancji_wzorcowej] DEFAULT ('') FOR [typ_gwarancji_wzorcowej],
	CONSTRAINT [PK_Towary] PRIMARY KEY  NONCLUSTERED 
	(
		[towarID]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_Towary] UNIQUE  NONCLUSTERED 
	(
		[kod]
	)  ON [PRIMARY] 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Towary_1] ON [Towary]([pn]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Towary_2] ON [Towary]([kategoria]) ON [PRIMARY]
GO

-- V 1.01
-- dodanie producenta, nr_katalogowy i nr_rys do towarw

IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Towary] ADD producentID int NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Towary_3] ON [Towary](producentID)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 ALTER TABLE [Towary] WITH NOCHECK ADD CONSTRAINT [FK_Towary_Kontrahenci] FOREIGN KEY (producentID) REFERENCES Kontrahenci(kontrahentID)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Towary] ADD nr_katalogowy nvarchar (50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Towary_4] ON [Towary](nr_katalogowy)
GO

IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Towary] ADD nr_rys nvarchar (50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Towary_5] ON [Towary](nr_rys)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.13)=0
ALTER TABLE [Towary] ADD powtSN bit NOT NULL DEFAULT 0
GO

-- V 1.14
-- dodanie pola wymaganeSN 
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.14)=0
ALTER TABLE [Towary] ADD wymaganeSN bit NOT NULL DEFAULT 1
GO
-- V 1.16
-- typ gwarancji moe by null
-- dodanie gwarancji producenta
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
ALTER TABLE [Towary] ALTER COLUMN [typ_gwarancji_wzorcowej] [nvarchar] (50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
UPDATE Towary SET typ_gwarancji_wzorcowej=NULL WHERE typ_gwarancji_wzorcowej=''
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
ALTER TABLE [Towary] ADD [typ_gwarancji_wzorcowejPR] [nvarchar] (50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
UPDATE Towary SET typ_gwarancji_wzorcowejPR=typ_gwarancji_wzorcowej WHERE typ_gwarancji_wzorcowejPR is null
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
ALTER TABLE [Towary] WITH NOCHECK ADD [gwarancja_wzorcowaPR] [int] NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
UPDATE Towary SET gwarancja_wzorcowaPR=gwarancja_wzorcowa WHERE gwarancja_wzorcowaPR is null
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
UPDATE Towary SET gwarancja_wzorcowa=NULL WHERE gwarancja_wzorcowa=0
GO
-- V 1.18
-- Dodano pole importuj_elementy
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.18)=0
ALTER TABLE [Towary] ADD importuj_elementy bit NOT NULL DEFAULT 0
GO

-- V 1.19
-- Dodano pole data i uytkownik tworz
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.19)=0
ALTER TABLE Towary ADD uzytkownik_tworzID int NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.19)=0
ALTER TABLE Towary ADD CONSTRAINT FK_Towary_Uzytkownicy1 FOREIGN KEY 
	(uzytkownik_tworzID) REFERENCES Uzytkownicy(uzytkownikID)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.19)=0
ALTER TABLE Towary ADD data_tworz [smalldatetime] NULL
GO
-- V 1.19
-- Dodano pole data i uytkownik modyf
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.19)=0
ALTER TABLE Towary ADD uzytkownik_modyfID int NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.19)=0
ALTER TABLE Towary ADD CONSTRAINT FK_Towary_Uzytkownicy2 FOREIGN KEY 
	(uzytkownik_modyfID) REFERENCES Uzytkownicy(uzytkownikID)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.19)=0
ALTER TABLE Towary ADD data_modyf [smalldatetime] NULL
GO
-- V 1.26
-- dodano Kod2
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.26)=0
ALTER TABLE Towary ADD kod2 [nvarchar] (100) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.26)=0
 CREATE  INDEX [IX_Towary_6] ON [Towary](kod2)
GO
-- V 1.31
-- dodano mask
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.31)=0
ALTER TABLE Towary ADD mask [nvarchar] (100) NULL
GO
-- V 1.41
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.41)=0
ALTER TABLE [Towary] ALTER COLUMN [data_tworz] [datetime]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.41)=0
ALTER TABLE [Towary] ALTER COLUMN [data_modyf] [datetime]
GO




PRINT '### TowaryFirm ###'
-- V 1.34
-- dodano wiele nazw
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
CREATE TABLE [TowaryFirm] (
	[towar_firmyID] [int] IDENTITY (1, 1) NOT NULL ,
	[firmaID] [int] NOT NULL ,
	[towarID] [int] NOT NULL ,
	[nazwa_firmowa] [nvarchar] (255) NOT NULL ,
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
ALTER TABLE [TowaryFirm] WITH NOCHECK ADD 
	CONSTRAINT [PK_TowaryFirm] PRIMARY KEY  NONCLUSTERED 
	(
		[towar_firmyID]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_TowaryFirm] UNIQUE  NONCLUSTERED 
	(
		[towarID], [firmaID]
	)  ON [PRIMARY] 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
 CREATE  INDEX [IX_TowaryFirm_1] ON [TowaryFirm]([towarID],[firmaID]) ON [PRIMARY]
GO

PRINT '### TowaryKontrahentow ###'
-- V 1.34
-- dodano wiele nazw
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
CREATE TABLE [TowaryKontrahentow] (
	[towar_kontrahentaID] [int] IDENTITY (1, 1) NOT NULL ,
	[kontrahentID] [int] NOT NULL ,
	[towarID] [int] NOT NULL ,
	[nazwa_firmowa] [nvarchar] (255) NOT NULL ,
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
ALTER TABLE [TowaryKontrahentow] WITH NOCHECK ADD 
	CONSTRAINT [PK_TowaryKontrahentow] PRIMARY KEY  NONCLUSTERED 
	(
		[towar_kontrahentaID]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_TowaryKontrahentow] UNIQUE  NONCLUSTERED 
	(
		[towarID], [kontrahentID]
	)  ON [PRIMARY] 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.34)=0
 CREATE  INDEX [IX_TowaryKontrahentow_1] ON [TowaryKontrahentow]([towarID],[kontrahentID]) ON [PRIMARY]
GO



PRINT '### Magazyny ###'
GO


IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE TABLE [Magazyny] (
	[magazynID] [int] IDENTITY (1, 1) NOT NULL ,
	[kod] [nvarchar] (80) NOT NULL ,
	[nazwa] [nvarchar] (255) NOT NULL ,
	[opis] [nvarchar] (255) NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Magazyny] WITH NOCHECK ADD 
	CONSTRAINT [PK_Magazyny] PRIMARY KEY  NONCLUSTERED 
	(
		[magazynID]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_Magazyny] UNIQUE  NONCLUSTERED 
	(
		[kod]
	)  ON [PRIMARY] 
GO

-- V 1.45
-- Dodano pole bezstanowy
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.45)=0
 ALTER TABLE Magazyny ADD [bezstanowy] smallint NOT NULL CONSTRAINT DF_Magazyny_bezstanowy DEFAULT 0
GO


PRINT '### Poladodatkowe ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.35)=0
CREATE TABLE [Poladodatkowe] (
	[poledodatkoweID] [int] IDENTITY (1, 1) NOT NULL ,
	[kod] [nvarchar] (50) NOT NULL ,
	[wymagane] [bit] NOT NULL ,
	[opis] [nvarchar] (255) NOT NULL ,
	[typbox] [nvarchar] (50) NOT NULL ,
	[wartosci] [nvarchar] (512) NOT NULL ,
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.35)=0
ALTER TABLE [Poladodatkowe] WITH NOCHECK ADD 
	CONSTRAINT [DF_Poladodatkowe_wymagane] DEFAULT (0) FOR [wymagane],
	CONSTRAINT [PK_Poladodatkowe] PRIMARY KEY  NONCLUSTERED 
	(
		[poledodatkoweID]
	)  ON [PRIMARY] 
GO


PRINT '### Typydzialan ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.36)=0
CREATE TABLE [Typydzialan] (
	[typdzialaniaID] [int] IDENTITY (1, 1) NOT NULL ,
	[nazwa] [nvarchar] (50) NOT NULL ,
	[opis] [nvarchar] (255) NULL ,
	[wymagane] [bit] NOT NULL ,
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.36)=0
ALTER TABLE [Typydzialan] WITH NOCHECK ADD 
	CONSTRAINT [PK_Typydzialan] PRIMARY KEY NONCLUSTERED ([typdzialaniaID]),
	CONSTRAINT [UK_TypydzialanNazwa] UNIQUE NONCLUSTERED ([nazwa])
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.36)=0
CREATE INDEX IX_TypydzialanNazwa ON Typydzialan(nazwa)
GO





PRINT '### Dokumenty ###'
GO


IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE TABLE [Dokumenty] (
	[dokumentID] [int] IDENTITY (1, 1) NOT NULL ,
	[firmaID] [int] NULL ,
	[typ] [nvarchar] (50) NOT NULL ,
	[data] [smalldatetime] NOT NULL ,
	[opis] [nvarchar] (255) NULL ,
	[faktura] [nvarchar] (50) NULL ,
	[numer] [nvarchar] (50) NOT NULL ,
	[zatwierdzony] [bit] NOT NULL ,
	[gotowy] [bit] NOT NULL ,
	[kontrahentID] [int] NULL ,
	[uzytkownikID] [int] NULL ,
	[data_zatwierdzenia] [smalldatetime] NULL ,
	[magazynID] [int] NULL ,
	[magazyn_zrodlowyID] [int] NULL ,
	[dokument_zrodlowyID] [int] NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Dokumenty] WITH NOCHECK ADD 
	CONSTRAINT [DF_Dokumenty_typ] DEFAULT ('PZ') FOR [typ],
	CONSTRAINT [DF_Dokumenty_data] DEFAULT (getdate()) FOR [data],
	CONSTRAINT [DF_Dokumenty_zatwierdzony] DEFAULT (0) FOR [zatwierdzony],
	CONSTRAINT [DF_Dokumenty_gotowy] DEFAULT (0) FOR [gotowy],
	CONSTRAINT [PK_Dokumenty] PRIMARY KEY  NONCLUSTERED 
	(
		[dokumentID]
	)  ON [PRIMARY] 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Dokumenty] ON [Dokumenty]([typ]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Dokumenty_1] ON [Dokumenty]([data]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Dokumenty_2] ON [Dokumenty]([faktura]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE UNIQUE NONCLUSTERED INDEX [IX_Dokumenty_3] ON [Dokumenty]([numer]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Dokumenty_4] ON [Dokumenty]([kontrahentID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Dokumenty_5] ON [Dokumenty]([uzytkownikID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Dokumenty_6] ON [Dokumenty]([data_zatwierdzenia]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Dokumenty_7] ON [Dokumenty]([magazynID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Dokumenty_8] ON [Dokumenty]([magazyn_zrodlowyID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Dokumenty_9] ON [Dokumenty]([dokument_zrodlowyID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Dokumenty] ADD 
	CONSTRAINT [FK_Dokumenty_firmy1] FOREIGN KEY 
	(
		[firmaID]
	) REFERENCES [Firmy] (
		[firmaID]
	),
	CONSTRAINT [FK_Dokumenty_Kontrahenci1] FOREIGN KEY 
	(
		[kontrahentID]
	) REFERENCES [Kontrahenci] (
		[kontrahentID]
	),
	CONSTRAINT [FK_Dokumenty_Magazyny] FOREIGN KEY 
	(
		[magazynID]
	) REFERENCES [Magazyny] (
		[magazynID]
	),
	CONSTRAINT [FK_Dokumenty_Magazyny1] FOREIGN KEY 
	(
		[magazyn_zrodlowyID]
	) REFERENCES [Magazyny] (
		[magazynID]
	),
	CONSTRAINT [FK_Dokumenty_Uzytkownicy] FOREIGN KEY 
	(
		[uzytkownikID]
	) REFERENCES [Uzytkownicy] (
		[uzytkownikID]
	),
	CONSTRAINT [FK_Dokumenty_Dokumenty] FOREIGN KEY
	(
		[dokument_zrodlowyID]
	) REFERENCES Dokumenty
	(
		[dokumentID]
	)
GO
-- V 1.09
-- Dodano pole faktura_dostawcy
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.09)=0
ALTER TABLE Dokumenty ADD faktura_zewnetrzna nvarchar(50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.09)=0
 CREATE  INDEX [IX_Dokumenty_10] ON [Dokumenty](faktura_zewnetrzna) ON [PRIMARY]
GO
-- V 1.11
-- Dodano pole data_dostawcy
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.11)=0
ALTER TABLE Dokumenty ADD data_dostawcy smalldatetime NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.11)=0
 CREATE  INDEX [IX_Dokumenty_11] ON [Dokumenty](data_dostawcy) ON [PRIMARY]
GO
-- V 1.12
-- Zmieniono pole data_dostawcy
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.12)=0
 EXECUTE sp_rename 'Dokumenty.data_dostawcy', 'data_zewnetrzna', 'COLUMN'
GO
-- V 1.14
-- Dodano pole gotowe_pozycje
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.14)=0
ALTER TABLE Dokumenty ADD gotowe_pozycje bit not null DEFAULT 0
GO
-- V 1.15
-- indeks na zatwierdzony
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.15)=0
ALTER TABLE Dokumenty DROP CONSTRAINT DF_Dokumenty_zatwierdzony
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.15)=0
ALTER TABLE Dokumenty ALTER COLUMN zatwierdzony smallint not null
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.15)=0
ALTER TABLE Dokumenty WITH NOCHECK ADD CONSTRAINT DF_Dokumenty_zatwierdzony DEFAULT (0) FOR zatwierdzony
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.15)=0
CREATE INDEX IX_Dokumenty_12 ON Dokumenty(zatwierdzony)
GO
-- V 1.17
-- data i uytkownik przygotowujcy, przewoznik, uytkownik tworzcy dokument
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.17)=0
ALTER TABLE Dokumenty ADD uzytkownik_przygID int NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.17)=0
ALTER TABLE Dokumenty ADD CONSTRAINT FK_Dokumenty_Uzytkownicy2 FOREIGN KEY 
	(uzytkownik_przygID) REFERENCES Uzytkownicy(uzytkownikID)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.17)=0
ALTER TABLE Dokumenty ADD data_przyg [smalldatetime] NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.17)=0
ALTER TABLE Dokumenty ADD uzytkownik_przewID int NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.17)=0
ALTER TABLE Dokumenty ADD CONSTRAINT FK_Dokumenty_Uzytkownicy3 FOREIGN KEY 
	(uzytkownik_przewID) REFERENCES Uzytkownicy(uzytkownikID)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.17)=0
ALTER TABLE Dokumenty ADD uzytkownik_tworzID int NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.17)=0
ALTER TABLE Dokumenty ADD CONSTRAINT FK_Dokumenty_Uzytkownicy4 FOREIGN KEY 
	(uzytkownik_tworzID) REFERENCES Uzytkownicy(uzytkownikID)
GO
-- V 1.20
-- pole gwarancyjny
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.20)=0
ALTER TABLE Dokumenty ADD gwarancyjny bit NOT NULL DEFAULT 0
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.20)=0
UPDATE Dokumenty SET gwarancyjny=1 WHERE typ='PZ' OR typ='WZ'
GO
-- V 1.25 (dodane pozniej)
--indexy dla magazynow
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.25)=0
CREATE INDEX IX_Dokumenty_13 ON Dokumenty(zatwierdzony, magazynID, magazyn_zrodlowyID)
GO
-- V 1.30
-- warunki gwarancyjne
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.30)=0
ALTER TABLE Dokumenty ADD warunki ntext NULL
GO
-- V 1.33
-- dokumenty bezstanowe
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.33)=0
ALTER TABLE Dokumenty ADD bezstanowy smallint null
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.33)=0
UPDATE Dokumenty SET bezstanowy=0 WHERE bezstanowy is null
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.33)=0
ALTER TABLE Dokumenty WITH NOCHECK ADD CONSTRAINT DF_Dokumenty_bezstanowy DEFAULT (0) FOR bezstanowy
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.33)=0
ALTER TABLE Dokumenty ALTER COLUMN bezstanowy smallint not null
GO
-- V 1.35
-- numer zlecenia i umowy
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.35)=0
ALTER TABLE Dokumenty ADD nr_zlecenia [nvarchar] (50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.35)=0
CREATE INDEX IX_Dokumenty_14 ON Dokumenty(nr_zlecenia)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.35)=0
ALTER TABLE Dokumenty ADD nr_umowy [nvarchar] (50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.35)=0
CREATE INDEX IX_Dokumenty_15 ON Dokumenty(nr_umowy)
GO
-- V 1.38
-- data planowanego zatwierdzenia
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.38)=0
ALTER TABLE Dokumenty ADD data_zatw_plan [smalldatetime] NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.38)=0
CREATE INDEX IX_Dokumenty_16 ON Dokumenty(data_zatw_plan)
GO
-- V 1.42
-- list przewozowy
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.42)=0
ALTER TABLE Dokumenty ADD list_przewozowy nvarchar(50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.42)=0
CREATE INDEX IX_Dokumenty_17 ON Dokumenty(list_przewozowy)
GO



PRINT '### Dzialania ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.36)=0
CREATE TABLE [Dzialania] (
	[dzialanieID] [int] IDENTITY (1, 1) NOT NULL ,
	[typdzialaniaID] [int] NOT NULL ,
	[dokumentID] [int] NOT NULL ,
	[uzytkownikID] [int] NOT NULL ,
	[data] [nvarchar] (255) NULL ,
	[opis] [nvarchar] (255) NULL ,
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.36)=0
ALTER TABLE [Dzialania] WITH NOCHECK ADD 
	CONSTRAINT [PK_Dzialania] PRIMARY KEY  NONCLUSTERED ([dzialanieID]),
	CONSTRAINT [FK_Dzialania_Uzytkownicy] FOREIGN KEY ([uzytkownikID]) REFERENCES [Uzytkownicy]([uzytkownikID]),
	CONSTRAINT [FK_Dzialania_Typydzialan] FOREIGN KEY ([typdzialaniaID]) REFERENCES [Typydzialan]([typdzialaniaID]),
	CONSTRAINT [FK_Dzialania_Dokumenty] FOREIGN KEY ([dokumentID]) REFERENCES [Dokumenty]([dokumentID])
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.36)=0
CREATE INDEX IX_Dzialania_1 ON Dzialania(dokumentID)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.36)=0
CREATE INDEX IX_Dzialania_2 ON Dzialania(dokumentID,typdzialaniaID)
GO




PRINT '### Pozycjeopis ###'
GO

IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE TABLE [Pozycjeopis] (
	[pozycjaopisID] [int] IDENTITY (1, 1) NOT NULL ,
	[dokumentID] [int] NOT NULL ,
	[towarID] [int] NULL ,
	[ilosc] [int] NOT NULL ,
	[gwarancja] [int] NULL ,
	[typ_gwarancji] [nvarchar] (50) NOT NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Pozycjeopis] WITH NOCHECK ADD 
	CONSTRAINT [DF_Pozycjeopis_ilosc] DEFAULT (0) FOR [ilosc],
	CONSTRAINT [DF_Pozycjeopis_typ_gwarancji] DEFAULT ('') FOR [typ_gwarancji],
	CONSTRAINT [PK_Pozycjeopis] PRIMARY KEY  NONCLUSTERED 
	(
		[pozycjaopisID]
	)  ON [PRIMARY] 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Pozycjeopis] ON [Pozycjeopis]([dokumentID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Pozycjeopis_1] ON [Pozycjeopis]([towarID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Pozycjeopis_2] ON [Pozycjeopis]([ilosc]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE UNIQUE NONCLUSTERED INDEX [IX_Pozycjeopis_3] ON [Pozycjeopis] (dokumentID,towarID) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Pozycjeopis] ADD 
	CONSTRAINT [FK_Pozycjeopis_Dokumenty] FOREIGN KEY 
	(
		[dokumentID]
	) REFERENCES [Dokumenty] (
		[dokumentID]
	),
	CONSTRAINT [FK_Pozycjeopis_Towary] FOREIGN KEY 
	(
		[towarID]
	) REFERENCES [Towary] (
		[towarID]
	)
GO
-- V 1.04
-- dodano pole ma_sn
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Pozycjeopis] WITH NOCHECK ADD
	[ma_sn] [bit] DEFAULT (0) NOT NULL
GO
-- V 1.08
-- dodano pole data_gwarancji do pozycjaopis, od ktrego liczy si gwarancj
-- umoliwiono powtarzanie towarw w dokumencie.
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.08)=0
ALTER TABLE [Pozycjeopis] WITH NOCHECK ADD [data_gwarancji] [smalldatetime] NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.08)=0
CREATE  INDEX [IX_Pozycjeopis_4] ON [Pozycjeopis]([data_gwarancji]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.08)=0
UPDATE Pozycjeopis SET data_gwarancji=(SELECT data FROM Dokumenty WHERE Dokumenty.dokumentID=Pozycjeopis.dokumentID) WHERE data_gwarancji is null
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.08)=0
DROP INDEX Pozycjeopis.IX_Pozycjeopis_3
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.08)=0
CREATE INDEX [IX_Pozycjeopis_3] ON [Pozycjeopis] (dokumentID,towarID) ON [PRIMARY]
GO
-- V 1.09
-- dodano pole pozycja zewntrzna
-- umoliwiono ilosc=null (obl. na podst. sn)
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.09)=0
ALTER TABLE [Pozycjeopis] ADD [pozycja_zewnetrzna] nvarchar(50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.09)=0
CREATE  INDEX [IX_Pozycjeopis_5] ON [Pozycjeopis]([pozycja_zewnetrzna]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.09)=0
ALTER TABLE [Pozycjeopis] ALTER COLUMN [ilosc] [int] NULL
GO
-- V 1.10
-- zmieniono interpretacj pola data_gwarancji na 'data_gwarancji do'
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.10)=0
UPDATE Pozycjeopis SET data_gwarancji=DATEADD(month,gwarancja,data_gwarancji) WHERE data_gwarancji is not null and gwarancja is not null
GO
-- V 1.16
-- typ gwarancji moe by null
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
ALTER TABLE [Pozycjeopis] ALTER COLUMN [typ_gwarancji] [nvarchar] (50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
UPDATE Pozycjeopis SET typ_gwarancji=NULL WHERE typ_gwarancji=''
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
UPDATE Pozycjeopis SET gwarancja=NULL WHERE gwarancja=0
GO
-- V 1.21
-- typ kompletacji w pozycjiopis dla kompletacji (pole komplet)
-- null, 0-element, 1-komplet
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
ALTER TABLE [Pozycjeopis] ADD [komplet] int NULL
GO
-- V 1.46
-- dodano pole ilosc_zwer - ilo zweryfikowana
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.46)=0
ALTER TABLE [Pozycjeopis] ADD [ilosc_zwer] int NULL
GO


PRINT '### Operacje ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE TABLE Operacje (
 	operacjaID int NOT NULL IDENTITY (1, 1),
	pozycjaopisID int NOT NULL,
	ilosc int NOT NULL,
	magazynID int NULL
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE Operacje WITH NOCHECK ADD
	CONSTRAINT PK_Operacje PRIMARY KEY NONCLUSTERED 
	(
		operacjaID
	) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX IX_Operacje ON Operacje (pozycjaopisID) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE INDEX IX_Operacje_1 ON Operacje (magazynID) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE Operacje WITH NOCHECK ADD
	CONSTRAINT FK_Operacje_Pozycjeopis FOREIGN KEY
	(
		pozycjaopisID
	) REFERENCES Pozycjeopis
	(
		pozycjaopisID
	)
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Operacje] ADD 
	CONSTRAINT [FK_Operacje_Magazyny] FOREIGN KEY 
	(
		[magazynID]
	) REFERENCES [Magazyny] (
		[magazynID]
	)
GO

-- V 1.04
-- Zrda nieuywane, poczone z Operacjami, dodanie kolumny pozycjaopis_zrodlowaID do operacji

IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 ALTER TABLE Operacje ADD pozycjaopis_zrodlowaID int NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE INDEX IX_Operacje_2 ON Operacje (pozycjaopis_zrodlowaID) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 ALTER TABLE Operacje ADD CONSTRAINT FK_Operacje_Pozycjeopis2
	FOREIGN KEY (pozycjaopis_zrodlowaID) REFERENCES Pozycjeopis (pozycjaopisID)
GO



PRINT '### Pozycje ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE TABLE [Pozycje] (
	[pozycjaID] [int] IDENTITY (1, 1) NOT NULL ,
	[dokumentID] [int] NOT NULL ,
	[towarID] [int] NOT NULL ,
	[ilosc] [int] NOT NULL ,
	[ilosc_na_stanie] [int] NOT NULL ,
	[gwarancja] [int] NULL ,
	[typ_gwarancji] [nvarchar] (50) NOT NULL ,
	[magazynID] [int] NULL ,
	[pozycjaopisID] [int] NOT NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Pozycje] WITH NOCHECK ADD 
	CONSTRAINT [DF_Pozycje_ilosc] DEFAULT (0) FOR [ilosc],
	CONSTRAINT [DF_Pozycje_ilosc_na_stanie] DEFAULT (0) FOR [ilosc_na_stanie],
	CONSTRAINT [DF_Pozycje_gwarancja] DEFAULT (0) FOR [gwarancja],
	CONSTRAINT [DF_Pozycje_typ_gwarancji] DEFAULT ('') FOR [typ_gwarancji],
	CONSTRAINT [PK_Pozycje] PRIMARY KEY  NONCLUSTERED 
	(
		[pozycjaID]
	)  ON [PRIMARY] 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Pozycje] ON [Pozycje]([dokumentID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Pozycje_1] ON [Pozycje]([towarID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Pozycje_2] ON [Pozycje]([ilosc]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Pozycje_3] ON [Pozycje]([ilosc_na_stanie]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Pozycje_4] ON [Pozycje]([magazynID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Pozycje_5] ON [Pozycje]([pozycjaopisID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Pozycje] ADD 
	CONSTRAINT FK_Pozycje_Dokumenty FOREIGN KEY
	(
		[dokumentID]
	) REFERENCES [Dokumenty] (
		[dokumentID]
	),
	CONSTRAINT [FK_Pozycje_Magazyny] FOREIGN KEY 
	(
		[magazynID]
	) REFERENCES [Magazyny] (
		[magazynID]
	),
	CONSTRAINT [FK_Pozycje_Towary] FOREIGN KEY 
	(
		[towarID]
	) REFERENCES [Towary] (
		[towarID]
	),
	CONSTRAINT [FK_Pozycje_PozycjeOpis] FOREIGN KEY 
	(
		[pozycjaopisID]
	) REFERENCES [Pozycjeopis] (
		[pozycjaopisID]
	)
GO
-- V 1.04
-- dodano pole ma_sn
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Pozycje] WITH NOCHECK ADD
	[ma_sn] [bit] DEFAULT (0) NOT NULL
GO
-- V 1.08
-- usunito pola dot. gwarancji dla tabeli Pozycje
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.08)=0
	ALTER TABLE Pozycje DROP CONSTRAINT [DF_Pozycje_gwarancja]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.08)=0
	ALTER TABLE Pozycje DROP CONSTRAINT [DF_Pozycje_typ_gwarancji]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.08)=0
	ALTER TABLE Pozycje DROP COLUMN [gwarancja]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.08)=0
	ALTER TABLE Pozycje DROP COLUMN [typ_gwarancji]
GO



PRINT '### Snpozopis ###'
GO

IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE TABLE [Snpozopis] (
	[snpozopisID] [int] IDENTITY (1, 1) NOT NULL ,
	[pozycjaopisID] [int] NOT NULL ,
	[snod] [nvarchar] (50) NULL ,
	[sndo] [nvarchar] (50) NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpozopis] WITH NOCHECK ADD 
	CONSTRAINT [PK_Snpozopis] PRIMARY KEY  NONCLUSTERED 
	(
		[snpozopisID]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_Snpozopis] UNIQUE  NONCLUSTERED 
	(
		[snod],
		[sndo],
		[pozycjaopisID]
	)  ON [PRIMARY] 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Snpozopis_1] ON [Snpozopis]([snod]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Snpozopis_2] ON [Snpozopis]([sndo]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Snpozopis_3] ON [Snpozopis]([pozycjaopisID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpozopis] ADD 
	CONSTRAINT [FK_Snpozopis_Pozycjeopis] FOREIGN KEY 
	(
		[pozycjaopisID]
	) REFERENCES [Pozycjeopis] (
		[pozycjaopisID]
	)
GO

-- V 1.06
-- Dodanie ilosc_sn, psn - pack sn, sprawdzanie powt. na kliencie
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpozopis] ADD ilosc_sn int NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
UPDATE Snpozopis SET ilosc_sn=1 WHERE ilosc_sn is null
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpozopis] DROP CONSTRAINT IX_Snpozopis
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpozopis] ADD psn nvarchar (50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE  INDEX [IX_Snpozopis_4] ON [Snpozopis]([psn]) ON [PRIMARY]
GO
-- V 1.16
-- Skasowanie sndo, psn
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
DROP INDEX Snpozopis.IX_Snpozopis_2
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
ALTER TABLE Snpozopis DROP COLUMN sndo
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
DROP INDEX Snpozopis.IX_Snpozopis_4
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
ALTER TABLE Snpozopis DROP COLUMN psn
GO




PRINT '### Snpoz ###'
GO


IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE TABLE [Snpoz] (
	[snpozID] [int] IDENTITY (1, 1) NOT NULL ,
	[pozycjaID] [int] NOT NULL ,
	[sn] [nvarchar] (50) NOT NULL ,
	[na_stanie] [bit] NOT NULL ,
	[snpozopisID] [int] NOT NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpoz] WITH NOCHECK ADD 
	CONSTRAINT [DF_Snpoz_na_stanie] DEFAULT (0) FOR [na_stanie],
	CONSTRAINT [PK_Snpoz] PRIMARY KEY  NONCLUSTERED 
	(
		[snpozID]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_Snpoz_3] UNIQUE  NONCLUSTERED 
	(
		[pozycjaID],
		[sn]
	)  ON [PRIMARY] 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Snpoz] ON [Snpoz]([pozycjaID]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
 CREATE  INDEX [IX_Snpoz_1] ON [Snpoz]([sn]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpoz] ADD 
	CONSTRAINT [FK_Snpoz_Pozycje] FOREIGN KEY 
	(
		[pozycjaID]
	) REFERENCES [Pozycje] (
		[pozycjaID]
	),
	CONSTRAINT [FK_Snpoz_Snpozopis] FOREIGN KEY 
	(
		[snpozopisID]
	) REFERENCES [Snpozopis] (
		[snpozopisID]
	)
GO

-- V 1.06
-- na_stanie -> int
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpoz] 
	DROP CONSTRAINT DF_Snpoz_na_stanie
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpoz] 
	ALTER COLUMN na_stanie int NOT NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpoz] WITH NOCHECK ADD 
	CONSTRAINT [DF_Snpoz_na_stanie] DEFAULT (0) FOR [na_stanie]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpoz] ADD psn nvarchar (50) NULL
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
CREATE  INDEX [IX_Snpoz_4] ON [Snpoz]([psn]) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.06)=0
ALTER TABLE [Snpoz] WITH NOCHECK ADD 
	CONSTRAINT [IX_Snpoz_5] UNIQUE  NONCLUSTERED 
	(
		[pozycjaID],
		[psn]
	)  ON [PRIMARY] 
GO
-- V 1.07
-- Snpoz psn not unique
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.07)=0
ALTER TABLE [Snpoz] DROP CONSTRAINT IX_Snpoz_5
GO


-- V 1.16
-- Skasowanie psn
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
DROP INDEX Snpoz.IX_Snpoz_4
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
ALTER TABLE Snpoz DROP COLUMN psn
GO


-- brakujcy index
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.16)=0
CREATE INDEX [IX_Snpoz6] On Snpoz([snpozopisID])
GO


-- v 1.18
-- Dodano tabele Zestawy
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.18)=0
CREATE TABLE [Zestawy] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[zestawID] [int] NOT NULL ,
	[elementID] [int] NOT NULL ,
	[ilosc] [int] NULL 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.18)=0
ALTER TABLE [Zestawy] WITH NOCHECK ADD 
	CONSTRAINT [PK_Zestawy] PRIMARY KEY  NONCLUSTERED
	(
		[ID]
	)  ON [PRIMARY] 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.18)=0
ALTER TABLE [Zestawy] ADD 
	CONSTRAINT [FK_Zestawy_Towary] FOREIGN KEY 
	(
		[zestawID]
	) REFERENCES [Towary] (
		[towarID]
	),
	CONSTRAINT [FK_Zestawy_Towary1] FOREIGN KEY 
	(
		[elementID]
	) REFERENCES [Towary] (
		[towarID]
	)
GO
-- v 1.21
-- Dodano indeksy do Zestawy
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
 CREATE  INDEX IX_Zestawy_1 ON Zestawy(zestawID) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
 CREATE  INDEX IX_Zestawy_2 ON Zestawy(elementID) ON [PRIMARY]
GO


-- v 1.21
-- Dodano tabele Komplety
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
CREATE TABLE [Komplety] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[dokumentID] [int] NOT NULL ,
	[pozopisID] [int] NOT NULL ,
	[snpozopisID] [int] NULL ,
	[ilosc] [int] NOT NULL CONSTRAINT [DF_Komplety_Ilosc] DEFAULT (0),
	CONSTRAINT [PK_Kompletacje] PRIMARY KEY
	(
		[ID]
	)  ON [PRIMARY] ,
	CONSTRAINT [FK_Komplety_Dokumenty] FOREIGN KEY 
	(
		[dokumentID]
	) REFERENCES [Dokumenty] (
		[dokumentID]
	),
	CONSTRAINT [FK_Komplety_PozycjeOpis] FOREIGN KEY 
	(
		[pozopisID]
	) REFERENCES [Pozycjeopis] (
		[pozycjaopisID]
	),
	CONSTRAINT [FK_Komplety_SNPozOpis] FOREIGN KEY 
	(
		[snpozopisID]
	) REFERENCES [Snpozopis] (
		[snpozopisID]
	)  
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
 CREATE  INDEX IX_Komplety_1 ON Komplety(dokumentID) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
 CREATE  INDEX IX_Komplety_2 ON Komplety(pozopisID) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
 CREATE  INDEX IX_Komplety_3 ON Komplety(snpozopisID) ON [PRIMARY]
GO


-- v 1.21
-- Dodano tabele Elementy
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
CREATE TABLE [Elementy] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[dokumentID] [int] NOT NULL ,
	[pozopisID] [int] NOT NULL ,
	[snpozopisID] [int] NULL ,
	[kompletID] [int] NOT NULL ,
	[ilosc] [int] NOT NULL CONSTRAINT [DF_Elementy_Ilosc] DEFAULT (0),
	CONSTRAINT [PK_Elementy] PRIMARY KEY
	(
		[ID]
	)  ON [PRIMARY] ,
	CONSTRAINT [FK_Elementy_Dokumenty] FOREIGN KEY 
	(
		[dokumentID]
	) REFERENCES [Dokumenty] (
		[dokumentID]
	),
	CONSTRAINT [FK_Elementy_Komplety] FOREIGN KEY 
	(
		[kompletID]
	) REFERENCES [Komplety] (
		[ID]
	),
	CONSTRAINT [FK_Elementy_PozycjeOpis] FOREIGN KEY 
	(
		[pozopisID]
	) REFERENCES [Pozycjeopis] (
		[pozycjaopisID]
	),
	CONSTRAINT [FK_Elementy_SNPozOpis] FOREIGN KEY 
	(
		[snpozopisID]
	) REFERENCES [Snpozopis] (
		[snpozopisID]
	) 
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
 CREATE  INDEX IX_Elementy_1 ON Elementy(dokumentID) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
 CREATE  INDEX IX_Elementy_2 ON Elementy(pozopisID) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
 CREATE  INDEX IX_Elementy_3 ON Elementy(snpozopisID) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.21)=0
 CREATE  INDEX IX_Elementy_4 ON Elementy(kompletID) ON [PRIMARY]
GO




PRINT '### HistoriaDokumentow ###'
GO

IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.23)=0
CREATE TABLE [HistoriaDokumentow] (
	[historiaDokumentuID] [int] IDENTITY (1, 1) NOT NULL ,
	[typ] [varchar] (50) NOT NULL ,
	[dokumentID] [int] NOT NULL ,
	[uzytkownikID] [int] NOT NULL ,
	[data] [smalldatetime] NOT NULL 
	CONSTRAINT [PK_HistoriaDokumentow] PRIMARY KEY
	(
		[historiaDokumentuID]
	)  ON [PRIMARY] ,
) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.23)=0
 CREATE  INDEX IX_HistoriaDokumentow_1 ON HistoriaDokumentow(data) ON [PRIMARY]
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.23)=0
 CREATE  INDEX IX_HistoriaDokumentow_2 ON HistoriaDokumentow(dokumentID) ON [PRIMARY]
GO


IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.25)=0
ALTER TABLE HistoriaDokumentow
	ALTER COLUMN [uzytkownikID] [int] NULL 
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.25)=0
UPDATE HistoriaDokumentow SET uzytkownikID=null WHERE uzytkownikID=0
GO




PRINT '### Dziennik ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.46)=0
BEGIN
 CREATE TABLE [Dziennik] (
  [dziennikID] [int] IDENTITY (1, 1) NOT NULL ,
  [modul] [nvarchar] (50) NOT NULL ,
  [data] [smalldatetime] NOT NULL ,
  [uzytkownikID] [int] NULL ,
  [opis] [nvarchar] (255) NULL
 ) ON [PRIMARY]
 ALTER TABLE [Dziennik] WITH NOCHECK ADD CONSTRAINT [PK_Dziennik] PRIMARY KEY NONCLUSTERED (dziennikID) ON [PRIMARY]
 CREATE INDEX [IX_dziennik_uzytkownikID] ON [Dziennik](uzytkownikID)
END
GO



PRINT '### Egzemplarze ###'
GO
IF (SELECT COUNT(*) FROM Opcje WHERE nazwa='BaseVersion' AND CAST(wartosc AS float(24))>=1.46)=0
BEGIN
 CREATE TABLE [Egzemplarze] (
  [egzemplarzID] [int] IDENTITY (1, 1) NOT NULL ,
  [sn] [nvarchar] (50) NOT NULL ,
  [sn2] [nvarchar] (50) NULL ,
  [data_modyfikacji] [smalldatetime] NOT NULL ,
  [uzytkownikID] [int] NULL ,
  [opis] [nvarchar] (255) NULL
 ) ON [PRIMARY]
 ALTER TABLE [Egzemplarze] WITH NOCHECK ADD
	CONSTRAINT [PK_Egzemplarze] PRIMARY KEY NONCLUSTERED (egzemplarzID),
	CONSTRAINT [FK_Egzemplarze_Uzytkownicy] FOREIGN KEY ([uzytkownikID]) REFERENCES [Uzytkownicy]([uzytkownikID])
 CREATE UNIQUE NONCLUSTERED INDEX [IX_Egzemplarze_sn] ON [Egzemplarze](sn)
 CREATE INDEX [IX_Egzemplarze_sn2] ON [Egzemplarze](sn2)
 CREATE INDEX [IX_Egzemplarze_uzytkownikID] ON [Egzemplarze](uzytkownikID)
 CREATE INDEX [IX_Egzemplarze_data_modyfikacji] ON Egzemplarze(data_modyfikacji)
END
GO



PRINT '### Widoki ###'
GO


PRINT '### VIEW QEgzemplarze ###'
GO
IF (OBJECT_ID('QEgzemplarze') IS NULL) EXEC ('CREATE VIEW QEgzemplarze AS SELECT * FROM Egzemplarze')
GO
ALTER VIEW QEgzemplarze
AS
SELECT Egzemplarze.*,
    Uzytkownicy.kod AS kod_uzytkownika
FROM Egzemplarze
    LEFT JOIN Uzytkownicy ON Uzytkownicy.uzytkownikID = Egzemplarze.uzytkownikID
GO




PRINT '### VIEW QTowaryKontrahentow ###'
GO
IF (OBJECT_ID('QTowaryKontrahentow') IS NULL) EXEC ('CREATE VIEW QTowaryKontrahentow AS SELECT * FROM Opcje')
GO
ALTER VIEW QTowaryKontrahentow
AS
SELECT TowaryKontrahentow.*,
    Towary.kod AS kod_towaru, 
    Towary.nazwa AS nazwa_towaru,
    Towary.pn,
    Kontrahenci.kod AS kod_kontrahenta, 
    Kontrahenci.nazwa AS nazwa_kontrahenta, 
    Kontrahenci.nip AS nip_kontrahenta
FROM TowaryKontrahentow
    LEFT JOIN Towary ON TowaryKontrahentow.towarID = Towary.towarID
    LEFT JOIN Kontrahenci ON TowaryKontrahentow.kontrahentID = Kontrahenci.kontrahentID
GO



PRINT '### VIEW VElementyZestawu ###'
GO
IF (OBJECT_ID('VElementyZestawu') IS NULL) EXEC ('CREATE VIEW VElementyZestawu AS SELECT * FROM Opcje')
GO
ALTER VIEW VElementyZestawu
AS
SELECT     Zestawy.*, Towary.kod, Towary.nazwa, Towary.pn
FROM       Zestawy
INNER JOIN Towary ON Zestawy.ElementID = Towary.towarID
GO



PRINT '### VIEW VKomplety ###'
GO
IF (OBJECT_ID('VKomplety') IS NULL) EXEC ('CREATE VIEW VKomplety AS SELECT * FROM Opcje')
GO
ALTER VIEW VKomplety
AS
SELECT Komplety.*, Snpozopis.snod AS snod, 
    Pozycjeopis.towarID AS towarID, 
    Towary.kod AS kod_towaru, 
    Towary.nazwa AS nazwa_towaru, 
    (SELECT nazwa_firmowa FROM TowaryFirm WHERE TowaryFirm.towarID=Towary.towarID AND TowaryFirm.firmaID=Dokumenty.firmaID) as nazwa_towaru_f,
    (SELECT nazwa_firmowa FROM TowaryKontrahentow WHERE TowaryKontrahentow.towarID=Towary.towarID AND TowaryKontrahentow.kontrahentID=Dokumenty.kontrahentID) as nazwa_towaru_k,
    Towary.pn AS pn_towaru, Towary.powtSN AS powtSN, 
    Towary.wymaganeSN AS wymaganeSN, 
    Dokumenty.zatwierdzony,
    Dokumenty.faktura,
    Dokumenty.nr_zlecenia,Dokumenty.nr_umowy,Dokumenty.list_przewozowy,
    Dokumenty.numer,
    Dokumenty.data, Dokumenty.typ, 
    Dokumenty.data_zatwierdzenia, 
    Dokumenty.opis
FROM Dokumenty INNER JOIN
    Komplety INNER JOIN
    Towary INNER JOIN
    Pozycjeopis ON 
    Towary.towarID = Pozycjeopis.towarID ON 
    Komplety.pozopisID = Pozycjeopis.pozycjaopisID ON 
    Dokumenty.dokumentID = Komplety.dokumentID LEFT OUTER JOIN
    Snpozopis ON Komplety.snpozopisID = Snpozopis.snpozopisID
GO





PRINT '### VIEW VElementy ###'
GO
IF (OBJECT_ID('VElementy') IS NULL) EXEC ('CREATE VIEW VElementy AS SELECT * FROM Opcje')
GO
ALTER VIEW VElementy
AS
SELECT Elementy.*, Pozycjeopis.towarID AS towarID, 
    Towary.kod AS kod_towaru, 
    Towary.nazwa AS nazwa_towaru, 
    (SELECT nazwa_firmowa FROM TowaryFirm WHERE TowaryFirm.towarID=Towary.towarID AND TowaryFirm.firmaID=Dokumenty.firmaID) as nazwa_towaru_f,
    (SELECT nazwa_firmowa FROM TowaryKontrahentow WHERE TowaryKontrahentow.towarID=Towary.towarID AND TowaryKontrahentow.kontrahentID=Dokumenty.kontrahentID) as nazwa_towaru_k,
    Towary.pn AS pn_towaru, Towary.powtSN AS powtSN, 
    Towary.wymaganeSN AS wymaganeSN, 
    Snpozopis.snod AS snod, Dokumenty.typ, 
    Dokumenty.data, 
    Dokumenty.opis, 
    Dokumenty.faktura,
    Dokumenty.nr_zlecenia,Dokumenty.nr_umowy,Dokumenty.list_przewozowy,
    Dokumenty.numer, 
    Dokumenty.zatwierdzony, 
    Dokumenty.data_zatwierdzenia,
	Dokumenty.magazynID, 
	Dokumenty.magazyn_zrodlowyID,
	Magazyny.kod AS kod_magazynu, 
	Magazyny.nazwa AS nazwa_magazynu,
	MagazynyZrdl.kod AS kod_magazynu_zrodl,
	MagazynyZrdl.nazwa AS nazwa_magazynu_zrodl,
	Kontrahenci.kod AS kod_kontrahenta, 
	Kontrahenci.nazwa AS nazwa_kontrahenta,
	Kontrahenci.nip AS nip_kontrahenta
FROM
	Dokumenty LEFT OUTER JOIN
	Magazyny ON Dokumenty.magazynID = Magazyny.magazynID LEFT OUTER JOIN
	Magazyny AS MagazynyZrdl ON Dokumenty.magazyn_zrodlowyID = MagazynyZrdl.magazynID LEFT OUTER JOIN
	Kontrahenci ON Dokumenty.kontrahentID = Kontrahenci.kontrahentID RIGHT OUTER JOIN
	Komplety ON Dokumenty.dokumentID = Komplety.dokumentID RIGHT OUTER JOIN
	Elementy LEFT OUTER JOIN
	Pozycjeopis ON Elementy.pozopisID = Pozycjeopis.pozycjaopisID ON Komplety.ID = Elementy.kompletID LEFT OUTER JOIN
	Towary ON Pozycjeopis.towarID = Towary.towarID LEFT OUTER JOIN
	Snpozopis ON Elementy.snpozopisID = Snpozopis.snpozopisID
	
GO





PRINT '### VIEW VElementyEx ###'
GO
IF (OBJECT_ID('VElementyEx') IS NULL) EXEC ('CREATE VIEW VElementyEx AS SELECT * FROM Opcje')
GO
ALTER VIEW VElementyEx
AS
SELECT VElementy.*,
    Snpozopis.snod AS snod_komp,
    Towary.kod AS kod_towaru_komp,
    Towary.nazwa AS nazwa_towaru_komp,
    nazwa_towaru_f as nazwa_towaru_komp_f,
    nazwa_towaru_k as nazwa_towaru_komp_k,
    Towary.pn AS pn_komp,
    Komplety.snpozopisID AS snpozopisID_komp, Komplety.pozopisID AS pozycjaopidID_komp
FROM VElementy LEFT OUTER JOIN
    Snpozopis RIGHT OUTER JOIN
    Komplety ON Snpozopis.snpozopisID = Komplety.snpozopisID LEFT OUTER JOIN
    Towary RIGHT OUTER JOIN
    Pozycjeopis ON Towary.towarID = Pozycjeopis.towarID ON Komplety.pozopisID = Pozycjeopis.pozycjaopisID ON 
    VElementy.kompletID = Komplety.ID
    LEFT OUTER JOIN Dokumenty On VElementy.dokumentID=Dokumenty.dokumentID
GO



PRINT '### VIEW QDokumenty ###'
GO

/****** Object:  View QDokumenty    Script Date: 2002-03-26 03:00:15 ******/
IF (OBJECT_ID('QDokumenty') IS NULL) EXEC ('CREATE VIEW QDokumenty AS SELECT * FROM Opcje')
GO
ALTER VIEW QDokumenty
AS
SELECT Dokumenty.*, Kontrahenci.kod AS kod_kontrahenta,
    Kontrahenci.nazwa AS nazwa_kontrahenta,
    Kontrahenci.adres AS adres_kontrahenta,
    Kontrahenci.nip AS nip_kontrahenta,
    Kontrahenci.bank AS bank_kontrahenta,
    Kontrahenci.konto AS konto_kontrahenta,
    Magazyny.kod AS kod_magazynu,
    Magazyny.nazwa AS nazwa_magazynu,
    Magazyny.bezstanowy AS magazyn_bezstanowy,
    Magazyny_1.kod AS kod_magazynu_zrodl,
    Magazyny_1.nazwa AS nazwa_magazynu_zrodl,
    Magazyny_1.bezstanowy AS magazyn_zrodl_bezstanowy,
    CASE zatwierdzony WHEN 1 THEN '+' ELSE '' END AS zatwierdzonyEx,
    CASE gotowy WHEN 1 THEN '+' ELSE '' END AS gotowyEx,
    Uzytkownicy_tworz.kod AS kod_uzytk_tworz, Uzytkownicy_przyg.kod AS kod_uzytk_przyg, Uzytkownicy_zatw.kod AS kod_uzytkownika
FROM Magazyny RIGHT OUTER JOIN
    Kontrahenci RIGHT OUTER JOIN
    Magazyny Magazyny_1 RIGHT OUTER JOIN
    Dokumenty LEFT OUTER JOIN
    Uzytkownicy Uzytkownicy_przyg ON Dokumenty.uzytkownik_przygID = Uzytkownicy_przyg.uzytkownikID ON 
    Magazyny_1.magazynID = Dokumenty.magazyn_zrodlowyID ON Kontrahenci.kontrahentID = Dokumenty.kontrahentID ON 
    Magazyny.magazynID = Dokumenty.magazynID LEFT OUTER JOIN
    Uzytkownicy Uzytkownicy_zatw ON Dokumenty.uzytkownikID = Uzytkownicy_zatw.uzytkownikID LEFT OUTER JOIN
    Uzytkownicy Uzytkownicy_tworz ON Dokumenty.uzytkownik_tworzID = Uzytkownicy_tworz.uzytkownikID
GO


PRINT '### VIEW QDokumentyNZ ###'
GO
IF (OBJECT_ID('QDokumentyNZ') IS NULL) EXEC ('CREATE VIEW QDokumentyNZ AS SELECT * FROM Opcje')
GO
ALTER VIEW QDokumentyNZ
AS
SELECT QDokumenty.*
FROM QDokumenty
WHERE zatwierdzony=0
GO




PRINT '### VIEW QPozycje ###'
GO

/****** Object:  View QPozycje    Script Date: 2002-03-26 03:00:15 ******/
IF (OBJECT_ID('QPozycje') IS NULL) EXEC ('CREATE VIEW QPozycje AS SELECT * FROM Opcje')
GO
ALTER VIEW QPozycje
AS
SELECT Pozycje.*, Towary.kod AS kod_towaru, 
    Towary.nazwa AS nazwa_towaru,
    (SELECT nazwa_firmowa FROM TowaryFirm WHERE TowaryFirm.towarID=Towary.towarID AND TowaryFirm.firmaID=Dokumenty.firmaID) as nazwa_towaru_f,
    (SELECT nazwa_firmowa FROM TowaryKontrahentow WHERE TowaryKontrahentow.towarID=Towary.towarID AND TowaryKontrahentow.kontrahentID=Dokumenty.kontrahentID) as nazwa_towaru_k,
    Towary.pn, 
    Magazyny.kod AS kod_magazynu, 
    Magazyny.nazwa AS nazwa_magazynu
FROM Magazyny RIGHT JOIN
    (Pozycje LEFT JOIN
    Towary ON Pozycje.towarID = Towary.towarID) ON 
    Magazyny.magazynID = Pozycje.magazynID
    LEFT JOIN Dokumenty ON Pozycje.dokumentID=Dokumenty.dokumentID
GO


PRINT '### VIEW QPozycjeExHelp ###'
GO

/****** Object:  View QPozycjeExHelp ******/
IF (OBJECT_ID('QPozycjeExHelp') IS NULL) EXEC ('CREATE VIEW QPozycjeExHelp AS SELECT * FROM Opcje')
GO
ALTER VIEW QPozycjeExHelp
AS
SELECT Pozycje.*,
    Towary.kod AS kod_towaru, 
    Towary.nazwa AS nazwa_towaru,
    (SELECT nazwa_firmowa FROM TowaryFirm WHERE TowaryFirm.towarID=Towary.towarID AND TowaryFirm.firmaID=Dokumenty.firmaID) as nazwa_towaru_f,
    (SELECT nazwa_firmowa FROM TowaryKontrahentow WHERE TowaryKontrahentow.towarID=Towary.towarID AND TowaryKontrahentow.kontrahentID=Dokumenty.kontrahentID) as nazwa_towaru_k,
     Towary.pn,
    Towary.kategoria,
    Towary.gwarancja_wzorcowa, Towary.typ_gwarancji_wzorcowej,
    gwarancja, typ_gwarancji, data_gwarancji,
    Dokumenty.typ, 
    Dokumenty.data,
    Dokumenty.faktura,
    Dokumenty.nr_zlecenia,Dokumenty.nr_umowy,Dokumenty.list_przewozowy,
    Dokumenty.data_zewnetrzna, Dokumenty.faktura_zewnetrzna,
    Dokumenty.numer AS numer_dokumentu,
    Dokumenty.opis as opis_dokumentu,
    Dokumenty.warunki,
    Dokumenty.zatwierdzony,
    Dokumenty.gotowy,
    CASE zatwierdzony WHEN 1 THEN '+' ELSE '' END AS zatwierdzonyEx,
    CASE gotowy WHEN 1 THEN '+' ELSE '' END AS gotowyEx,
    Dokumenty.data_zatwierdzenia,
    Dokumenty.data_przyg,
    Uzytkownicy_tworz.kod AS kod_uzytk_tworz, Uzytkownicy_przyg.kod AS kod_uzytk_przyg, Uzytkownicy_zatw.kod AS kod_uzytkownika,
    Kontrahenci.kod AS kod_kontrahenta, 
    Kontrahenci.nazwa AS nazwa_kontrahenta, 
    Kontrahenci.nip AS nip_kontrahenta, 
    Magazyny.kod AS kod_magazynu, 
    Magazyny.nazwa AS nazwa_magazynu
FROM Uzytkownicy Uzytkownicy_zatw RIGHT OUTER JOIN
    Uzytkownicy Uzytkownicy_tworz RIGHT OUTER JOIN
    Dokumenty LEFT OUTER JOIN
    Uzytkownicy Uzytkownicy_przyg ON Dokumenty.uzytkownik_przygID = Uzytkownicy_przyg.uzytkownikID ON 
    Uzytkownicy_tworz.uzytkownikID = Dokumenty.uzytkownik_tworzID ON Uzytkownicy_zatw.uzytkownikID = Dokumenty.uzytkownikID LEFT OUTER JOIN
    Kontrahenci ON Dokumenty.kontrahentID = Kontrahenci.kontrahentID RIGHT OUTER JOIN
    Pozycjeopis RIGHT OUTER JOIN
    Pozycje ON Pozycjeopis.pozycjaopisID = Pozycje.pozycjaopisID LEFT OUTER JOIN
    Magazyny ON Pozycje.magazynID = Magazyny.magazynID ON Dokumenty.dokumentID = Pozycje.dokumentID LEFT OUTER JOIN
    Towary ON Pozycje.towarID = Towary.towarID
GO




PRINT '### VIEW QPozycjeEx ###'
GO

/****** Object:  View QPozycjeEx ******/
IF (OBJECT_ID('QPozycjeEx') IS NULL) EXEC ('CREATE VIEW QPozycjeEx AS SELECT * FROM Opcje')
GO
ALTER VIEW QPozycjeEx
AS
SELECT QPozycjeExHelp.*
FROM QPozycjeExHelp
WHERE pozycjaID is not null
GO



PRINT '### VIEW QPozycjeopis ###'
GO

/****** Object:  View QPozycjeopis    Script Date: 2002-03-26 03:00:15 ******/
IF (OBJECT_ID('QPozycjeopis') IS NULL) EXEC ('CREATE VIEW QPozycjeopis AS SELECT * FROM Opcje')
GO
ALTER VIEW QPozycjeopis
AS
SELECT Pozycjeopis.*,
    Towary.kod AS kod_towaru, 
    Towary.nazwa AS nazwa_towaru,
    (SELECT nazwa_firmowa FROM TowaryFirm WHERE TowaryFirm.towarID=Towary.towarID AND TowaryFirm.firmaID=Dokumenty.firmaID) as nazwa_towaru_f,
    (SELECT nazwa_firmowa FROM TowaryKontrahentow WHERE TowaryKontrahentow.towarID=Towary.towarID AND TowaryKontrahentow.kontrahentID=Dokumenty.kontrahentID) as nazwa_towaru_k,
    Towary.pn,
    Towary.wymaganeSN
FROM Pozycjeopis LEFT JOIN
    Towary ON Pozycjeopis.towarID = Towary.towarID
    LEFT JOIN Dokumenty ON Pozycjeopis.dokumentID=Dokumenty.dokumentID
GO






PRINT '### VIEW QPozycjeopisExHelp ###'
GO

/****** Object:  View QPozycjeopisExHelp ******/
IF (OBJECT_ID('QPozycjeopisExHelp') IS NULL) EXEC ('CREATE VIEW QPozycjeopisExHelp AS SELECT * FROM Opcje')
GO
ALTER VIEW QPozycjeopisExHelp
AS
SELECT Pozycjeopis.*, Towary.kod AS kod_towaru, 
    Towary.nazwa AS nazwa_towaru,
    (SELECT nazwa_firmowa FROM TowaryFirm WHERE TowaryFirm.towarID=Towary.towarID AND TowaryFirm.firmaID=Dokumenty.firmaID) as nazwa_towaru_f,
    (SELECT nazwa_firmowa FROM TowaryKontrahentow WHERE TowaryKontrahentow.towarID=Towary.towarID AND TowaryKontrahentow.kontrahentID=Dokumenty.kontrahentID) as nazwa_towaru_k,
    Towary.pn,
    Towary.kategoria,
    Dokumenty.typ, 
    Dokumenty.data,
    Dokumenty.faktura, 
    Dokumenty.nr_zlecenia,Dokumenty.nr_umowy,Dokumenty.list_przewozowy,
    Dokumenty.data_zewnetrzna, Dokumenty.faktura_zewnetrzna,
    Dokumenty.numer AS numer_dokumentu,
    Dokumenty.opis as opis_dokumentu,
	Dokumenty.warunki,
    Dokumenty.gwarancyjny,
    Dokumenty.dokument_zrodlowyID,
    Dokumenty.zatwierdzony, 
    Dokumenty.gotowy, 
    CASE zatwierdzony WHEN 1 THEN '+' ELSE '' END AS zatwierdzonyEx,
    CASE gotowy WHEN 1 THEN '+' ELSE '' END AS gotowyEx,
    Dokumenty.data_zatwierdzenia,
    Dokumenty.data_przyg,
    Uzytkownicy_tworz.kod AS kod_uzytk_tworz, Uzytkownicy_przyg.kod AS kod_uzytk_przyg, Uzytkownicy_zatw.kod AS kod_uzytkownika,
    Kontrahenci.kod AS kod_kontrahenta, 
    Kontrahenci.nazwa AS nazwa_kontrahenta, 
    Kontrahenci.nip AS nip_kontrahenta, 
    Dokumenty.magazynID AS magazynID, 
    Dokumenty.magazyn_zrodlowyID AS magazyn_zrodlowyID, 
    Magazyny.kod AS kod_magazynu, 
    Magazyny.nazwa AS nazwa_magazynu, 
    Magazyny_1.kod AS kod_magazynu_zrodl, 
    Magazyny_1.nazwa AS nazwa_magazynu_zrodl
FROM  Magazyny RIGHT OUTER JOIN
    Kontrahenci RIGHT OUTER JOIN
    Magazyny Magazyny_1 RIGHT OUTER JOIN
    Uzytkownicy Uzytkownicy_tworz RIGHT OUTER JOIN
    Dokumenty LEFT OUTER JOIN
    Uzytkownicy Uzytkownicy_przyg ON Dokumenty.uzytkownik_przygID = Uzytkownicy_przyg.uzytkownikID ON 
    Uzytkownicy_tworz.uzytkownikID = Dokumenty.uzytkownik_tworzID LEFT OUTER JOIN
    Uzytkownicy Uzytkownicy_zatw ON Dokumenty.uzytkownikID = Uzytkownicy_zatw.uzytkownikID ON 
    Magazyny_1.magazynID = Dokumenty.magazyn_zrodlowyID ON Kontrahenci.kontrahentID = Dokumenty.kontrahentID ON 
    Magazyny.magazynID = Dokumenty.magazynID FULL OUTER JOIN
    Pozycjeopis ON Dokumenty.dokumentID = Pozycjeopis.dokumentID FULL OUTER JOIN
    Towary ON Pozycjeopis.towarID = Towary.towarID
GO



PRINT '### VIEW QPozycjeopisEx ###'
GO

/****** Object:  View QPozycjeopisEx ******/
IF (OBJECT_ID('QPozycjeopisEx') IS NULL) EXEC ('CREATE VIEW QPozycjeopisEx AS SELECT * FROM Opcje')
GO
ALTER VIEW QPozycjeopisEx
AS
SELECT QPozycjeopisExHelp.*
FROM QPozycjeopisExHelp
WHERE pozycjaopisID is not null
GO



PRINT '### VIEW QSnpoz ###'
GO

/****** Object:  View QSnpoz    Script Date: 2002-03-26 03:00:15 ******/
IF (OBJECT_ID('QSnpoz') IS NULL) EXEC ('CREATE VIEW QSnpoz AS SELECT * FROM Opcje')
GO
ALTER VIEW QSnpoz
AS
SELECT Snpoz.*, 
    CASE na_stanie WHEN 1 THEN '+' ELSE '' END AS na_stanieEx,
    Magazyny.kod AS kod_magazynu, 
    Magazyny.nazwa AS nazwa_magazynu
FROM (Magazyny RIGHT JOIN
    Pozycje ON Magazyny.magazynID = Pozycje.magazynID) 
    RIGHT JOIN
    Snpoz ON Pozycje.pozycjaID = Snpoz.pozycjaID
GO


PRINT '### VIEW QSnpozExHelp ###'
GO

/****** Object:  View QSnpozExHelp ******/
IF (OBJECT_ID('QSnpozExHelp') IS NULL) EXEC ('CREATE VIEW QSnpozExHelp AS SELECT * FROM Opcje')
GO
ALTER VIEW QSnpozExHelp
AS
SELECT Snpoz.*, 
    CASE na_stanie WHEN 1 THEN '+' ELSE '' END AS na_stanieEx,
    COALESCE(Snpoz.na_stanie, QPozycjeExHelp.ilosc_na_stanie) as na_stanie_ex,
    QPozycjeExHelp.dokumentID,
    QPozycjeExHelp.towarID, QPozycjeExHelp.kod_towaru,
    QPozycjeExHelp.nazwa_towaru, QPozycjeExHelp.nazwa_towaru_f, QPozycjeExHelp.nazwa_towaru_k,
    QPozycjeExHelp.pn, QPozycjeExHelp.kategoria,
    QPozycjeExHelp.pozycjaopisID,
    QPozycjeExHelp.gwarancja, QPozycjeExHelp.typ_gwarancji, QPozycjeExHelp.data_gwarancji,
    QPozycjeExHelp.gwarancja_wzorcowa, QPozycjeExHelp.typ_gwarancji_wzorcowej,
    QPozycjeExHelp.data,
    QPozycjeExHelp.typ, QPozycjeExHelp.numer_dokumentu,
    QPozycjeExHelp.opis_dokumentu, 
	QPozycjeExHelp.warunki,
    QPozycjeExHelp.faktura,
    QPozycjeExHelp.nr_zlecenia,QPozycjeExHelp.nr_umowy,QPozycjeExHelp.list_przewozowy,
    QPozycjeExHelp.kod_kontrahenta, QPozycjeExHelp.nip_kontrahenta, 
    QPozycjeExHelp.data_zewnetrzna, QPozycjeExHelp.faktura_zewnetrzna,
    QPozycjeExHelp.nazwa_kontrahenta, QPozycjeExHelp.magazynID, QPozycjeExHelp.kod_magazynu, 
    QPozycjeExHelp.nazwa_magazynu,
    QPozycjeExHelp.zatwierdzony,
    QPozycjeExHelp.zatwierdzonyEx,

    QPozycjeExHelp.gotowy,
    QPozycjeExHelp.gotowyEx,
    QPozycjeExHelp.data_zatwierdzenia,
    QPozycjeExHelp.data_przyg,
    QPozycjeExHelp.kod_uzytk_tworz, QPozycjeExHelp.kod_uzytk_przyg, QPozycjeExHelp.kod_uzytkownika
FROM Snpoz RIGHT OUTER JOIN QPozycjeExHelp ON Snpoz.pozycjaID = QPozycjeExHelp.pozycjaID
GO


PRINT '### VIEW QSnpozEx ###'
GO

/****** Object:  View QSnpozEx ******/
IF (OBJECT_ID('QSnpozEx') IS NULL) EXEC ('CREATE VIEW QSnpozEx AS SELECT * FROM Opcje')
GO
ALTER VIEW QSnpozEx
AS
SELECT QSnpozExHelp.*
FROM QSnpozExHelp
WHERE snpozID is not null
GO


PRINT '### VIEW QSnpozopis ###'
GO
IF (OBJECT_ID('QSnpozopis') IS NULL) EXEC ('CREATE VIEW QSnpozopis AS SELECT * FROM Opcje')
GO
ALTER VIEW QSnpozopis
AS
SELECT * FROM Snpozopis
GO


PRINT '### VIEW QSnpozopisExHelp ###'
GO

/****** Object:  View QSnpozopisExHelp ******/
IF (OBJECT_ID('QSnpozopisExHelp') IS NULL) EXEC ('CREATE VIEW QSnpozopisExHelp AS SELECT * FROM Opcje')
GO
ALTER VIEW QSnpozopisExHelp
AS
SELECT
    Snpozopis.snpozopisID,
    Snpozopis.snod,
    Snpozopis.ilosc_sn,
    COALESCE(Snpozopis.ilosc_sn, QPozycjeopisExHelp.ilosc) as ilosc_sn_ex,
    (SELECT sn2 FROM Egzemplarze WHERE Egzemplarze.sn=Snpozopis.snod) as sn2,
    (SELECT opis FROM Egzemplarze WHERE Egzemplarze.sn=Snpozopis.snod) as opis_sn,
    QPozycjeopisExHelp.towarID, 
    QPozycjeopisExHelp.kod_towaru,
    QPozycjeopisExHelp.nazwa_towaru, QPozycjeopisExHelp.nazwa_towaru_f, QPozycjeopisExHelp.nazwa_towaru_k,
    QPozycjeopisExHelp.pn,
    QPozycjeopisExHelp.kategoria,
    QPozycjeopisExHelp.pozycja_zewnetrzna,
    QPozycjeopisExHelp.dokumentID,
    QPozycjeopisExHelp.pozycjaopisID,
    QPozycjeopisExHelp.ilosc,
    QPozycjeopisExHelp.gwarancja, QPozycjeopisExHelp.typ_gwarancji, QPozycjeopisExHelp.data_gwarancji,
    QPozycjeopisExHelp.komplet,
    QPozycjeopisExHelp.typ, 
    QPozycjeopisExHelp.data,
    QPozycjeopisExHelp.faktura,
    QPozycjeopisExHelp.nr_zlecenia,QPozycjeopisExHelp.nr_umowy,QPozycjeopisExHelp.list_przewozowy,
    QPozycjeopisExHelp.data_zewnetrzna, QPozycjeopisExHelp.faktura_zewnetrzna,
    QPozycjeopisExHelp.numer_dokumentu,
    QPozycjeopisExHelp.opis_dokumentu,
	QPozycjeopisExHelp.warunki,
    QPozycjeopisExHelp.gwarancyjny, 
    QPozycjeopisExHelp.zatwierdzony, 
    QPozycjeopisExHelp.zatwierdzonyEx,
    QPozycjeopisExHelp.gotowy,
    QPozycjeopisExHelp.gotowyEx,
    QPozycjeopisExHelp.data_zatwierdzenia,
    QPozycjeopisExHelp.data_przyg,
    QPozycjeopisExHelp.kod_uzytk_tworz, QPozycjeopisExHelp.kod_uzytk_przyg, QPozycjeopisExHelp.kod_uzytkownika,
    QPozycjeopisExHelp.kod_kontrahenta, QPozycjeopisExHelp.nazwa_kontrahenta, QPozycjeopisExHelp.nip_kontrahenta,
    QPozycjeopisExHelp.magazynID AS magazynID, 
    QPozycjeopisExHelp.magazyn_zrodlowyID AS magazyn_zrodlowyID, 
    QPozycjeopisExHelp.kod_magazynu, 
    QPozycjeopisExHelp.nazwa_magazynu, 
    QPozycjeopisExHelp.kod_magazynu_zrodl, 
    QPozycjeopisExHelp.nazwa_magazynu_zrodl
FROM Snpozopis RIGHT OUTER JOIN
        QPozycjeopisExHelp ON Snpozopis.pozycjaopisID = QPozycjeopisExHelp.pozycjaopisID
GO


PRINT '### VIEW QSnpozopisEx ###'
GO

/****** Object:  View QSnpozopisEx    Script Date: 2002-03-26 03:00:16 ******/
IF (OBJECT_ID('QSnpozopisEx') IS NULL) EXEC ('CREATE VIEW QSnpozopisEx AS SELECT * FROM Opcje')
GO
ALTER VIEW QSnpozopisEx
AS
SELECT QSnpozopisExHelp.*
FROM QSnpozopisExHelp
WHERE (snpozopisID*1) is not null
GO



PRINT '### VIEW QSnpozopisExHints ###'
GO

/****** Object:  View QSnpozopisExHints    Script Date: 2002-03-26 03:00:16 ******/
IF (OBJECT_ID('QSnpozopisExHints') IS NULL) EXEC ('CREATE VIEW QSnpozopisExHints AS SELECT * FROM Opcje')
GO
ALTER VIEW QSnpozopisExHints
AS
SELECT
    Snpozopis.snpozopisID, 
    Snpozopis.snod, 
    Snpozopis.ilosc_sn, 
    COALESCE(Snpozopis.ilosc_sn, QPozycjeopisEx.ilosc) as ilosc_sn_ex,
    (SELECT sn2 FROM Egzemplarze WHERE Egzemplarze.sn=Snpozopis.snod) as sn2,
    (SELECT opis FROM Egzemplarze WHERE Egzemplarze.sn=Snpozopis.snod) as opis_sn,
    QPozycjeopisEx.towarID, 
    QPozycjeopisEx.kod_towaru,
    QPozycjeopisEx.nazwa_towaru, QPozycjeopisEx.nazwa_towaru_f, QPozycjeopisEx.nazwa_towaru_k,
    QPozycjeopisEx.pn, QPozycjeopisEx.kategoria, QPozycjeopisEx.pozycja_zewnetrzna,
    QPozycjeopisEx.dokumentID, 
    QPozycjeopisEx.pozycjaopisID,
    QPozycjeopisEx.ilosc, 
    QPozycjeopisEx.gwarancja, QPozycjeopisEx.typ_gwarancji, QPozycjeopisEx.data_gwarancji, 
    QPozycjeopisEx.komplet,
    QPozycjeopisEx.typ, 
    QPozycjeopisEx.data,
    QPozycjeopisEx.faktura, 
    QPozycjeopisEx.nr_zlecenia,QPozycjeopisEx.nr_umowy,QPozycjeopisEx.list_przewozowy,
    QPozycjeopisEx.data_zewnetrzna, QPozycjeopisEx.faktura_zewnetrzna,
    QPozycjeopisEx.numer_dokumentu,
    QPozycjeopisEx.opis_dokumentu,
    QPozycjeopisEx.warunki,
    QPozycjeopisEx.gwarancyjny,
    QPozycjeopisEx.zatwierdzony, 
    QPozycjeopisEx.zatwierdzonyEx,
    QPozycjeopisEx.gotowy,
    QPozycjeopisEx.gotowyEx,
    QPozycjeopisEx.data_zatwierdzenia,
    QPozycjeopisEx.data_przyg,
    QPozycjeopisEx.kod_uzytk_tworz, QPozycjeopisEx.kod_uzytk_przyg, QPozycjeopisEx.kod_uzytkownika,
    QPozycjeopisEx.kod_kontrahenta, QPozycjeopisEx.nazwa_kontrahenta, QPozycjeopisEx.nip_kontrahenta,
    QPozycjeopisEx.magazynID AS magazynID, 
    QPozycjeopisEx.magazyn_zrodlowyID AS magazyn_zrodlowyID, 
    QPozycjeopisEx.kod_magazynu, 
    QPozycjeopisEx.nazwa_magazynu, 
    QPozycjeopisEx.kod_magazynu_zrodl, 
    QPozycjeopisEx.nazwa_magazynu_zrodl
FROM Snpozopis WITH (INDEX(IX_Snpozopis_3)) RIGHT JOIN
    QPozycjeopisEx ON 
    Snpozopis.pozycjaopisID = QPozycjeopisEx.pozycjaopisID
GO









PRINT '### VIEW QSnpozopisExx ###'
GO

IF (OBJECT_ID('QSnpozopisExx') IS NULL) EXEC ('CREATE VIEW QSnpozopisExx AS SELECT * FROM Opcje')
GO
ALTER VIEW QSnpozopisExx
AS
SELECT *
FROM QSnpozopisExHelp
GO


PRINT '### VIEW QOperacje ###'
GO
IF (OBJECT_ID('QOperacje') IS NULL) EXEC ('CREATE VIEW QOperacje AS SELECT * FROM Opcje')
GO
ALTER VIEW QOperacje
AS
SELECT Operacje.*, Pozycjeopis.dokumentID AS dokumentID,
    Pozycjeopis_zrodlowe.dokumentID AS dokumentID_zrodlowy, 
    Pozycjeopis.towarID AS towarID
FROM Operacje INNER JOIN
    Pozycjeopis ON
    Operacje.pozycjaopisID = Pozycjeopis.pozycjaopisID INNER JOIN
    Pozycjeopis Pozycjeopis_zrodlowe ON
    Operacje.pozycjaopis_zrodlowaID = Pozycjeopis_zrodlowe.pozycjaopisID
GO




PRINT '### VIEW QOperacjeExHelp ###'
GO
IF (OBJECT_ID('QOperacjeExHelp') IS NULL) EXEC ('CREATE VIEW QOperacjeExHelp AS SELECT * FROM Opcje')
GO
ALTER VIEW QOperacjeExHelp
AS
SELECT Operacje.*, Pozycjeopis.towarID, Towary.kod AS kod_towaru, 
    Towary.nazwa AS nazwa_towaru,
    (SELECT nazwa_firmowa FROM TowaryFirm WHERE TowaryFirm.towarID=Towary.towarID AND TowaryFirm.firmaID=Dokumenty.firmaID) as nazwa_towaru_f,
    (SELECT nazwa_firmowa FROM TowaryKontrahentow WHERE TowaryKontrahentow.towarID=Towary.towarID AND TowaryKontrahentow.kontrahentID=Dokumenty.kontrahentID) as nazwa_towaru_k,
    Towary.pn, 
    Towary.kategoria, Operacje.ilosc AS ilosc1, 
    Dokumenty.typ, Dokumenty.data,
    Dokumenty.faktura, Dokumenty.data_zewnetrzna, 
    Dokumenty.nr_zlecenia,Dokumenty.nr_umowy,Dokumenty.list_przewozowy,
    Dokumenty.faktura_zewnetrzna, 
    Dokumenty.numer AS numer_dokumentu, 
    Dokumenty.opis AS opis_dokumentu,
	Dokumenty.warunki,
    Dokumenty.gwarancyjny,
    CASE zatwierdzony WHEN 1 THEN '+' ELSE '' END AS zatwierdzonyEx,
    CASE gotowy WHEN 1 THEN '+' ELSE '' END AS gotowyEx,
    Dokumenty.data_zatwierdzenia,
    Dokumenty.data_przyg,
    Uzytkownicy_tworz.kod AS kod_uzytk_tworz, Uzytkownicy_przyg.kod AS kod_uzytk_przyg, Uzytkownicy_zatw.kod AS kod_uzytkownika,
    Kontrahenci.kod AS kod_kontrahenta, 
    Kontrahenci.nazwa AS nazwa_kontrahenta, 
    Kontrahenci.nip AS nip_kontrahenta, 
    Magazyny.kod AS kod_magazynu, 
    Magazyny.nazwa AS nazwa_magazynu,
    Dokumenty.zatwierdzony,
    Dokumenty.gotowy
FROM Towary INNER JOIN
    Pozycjeopis ON Towary.towarID = Pozycjeopis.towarID RIGHT OUTER JOIN
    Uzytkownicy Uzytkownicy_tworz RIGHT OUTER JOIN
    Dokumenty ON Uzytkownicy_tworz.uzytkownikID = Dokumenty.uzytkownik_tworzID LEFT OUTER JOIN
    Uzytkownicy Uzytkownicy_przyg ON Dokumenty.uzytkownik_przygID = Uzytkownicy_przyg.uzytkownikID LEFT OUTER JOIN
    Uzytkownicy Uzytkownicy_zatw ON Dokumenty.uzytkownikID = Uzytkownicy_zatw.uzytkownikID ON 
    Pozycjeopis.dokumentID = Dokumenty.dokumentID RIGHT OUTER JOIN
    Magazyny RIGHT OUTER JOIN
    Operacje ON Magazyny.magazynID = Operacje.magazynID ON Pozycjeopis.pozycjaopisID = Operacje.pozycjaopisID LEFT OUTER JOIN
    Kontrahenci ON Dokumenty.kontrahentID = Kontrahenci.kontrahentID
GO


PRINT '### VIEW QOperacjeEx ###'
GO
IF (OBJECT_ID('QOperacjeEx') IS NULL) EXEC ('CREATE VIEW QOperacjeEx AS SELECT * FROM Opcje')
GO
ALTER VIEW QOperacjeEx
AS
SELECT QOperacjeExHelp.*
FROM QOperacjeExHelp
WHERE operacjaID is not null
GO




PRINT '### VIEW QStany ###'
GO
IF (OBJECT_ID('QStany') IS NULL) EXEC ('CREATE VIEW QStany AS SELECT * FROM Opcje')
GO
ALTER VIEW QStany
AS
SELECT Pozycje.towarID,
    Towary.kod AS kod_towaru, Towary.kod2 AS kod2_towaru,
    Towary.nazwa AS nazwa_towaru,
    Towary.pn, Towary.kategoria,
    SUM(Pozycje.ilosc_na_stanie) AS ilosc_na_stanie_magazynu
FROM Towary LEFT JOIN
    Pozycje ON Towary.towarID = Pozycje.towarID
WHERE ((Pozycje.ilosc_na_stanie) > 0)
GROUP BY Pozycje.towarID, Pozycje.towarID, Towary.kod, Towary.kod2, Towary.nazwa, Towary.pn, Towary.kategoria
GO



PRINT '### VIEW QStanyMag ###'
GO
IF (OBJECT_ID('QStanyMag') IS NULL) EXEC ('CREATE VIEW QStanyMag AS SELECT * FROM Opcje')
GO
ALTER VIEW QStanyMag
AS
SELECT Pozycje.towarID,
    Towary.kod AS kod_towaru, Towary.kod2 AS kod2_towaru,
    Towary.nazwa AS nazwa_towaru,
    Towary.pn, Towary.kategoria,
    Pozycje.magazynID, Magazyny.kod AS kod_magazynu, 
    SUM(Pozycje.ilosc_na_stanie) AS ilosc_na_stanie_magazynu
FROM Towary RIGHT JOIN
    (Magazyny RIGHT JOIN Pozycje ON Magazyny.magazynID = Pozycje.magazynID) ON Towary.towarID = Pozycje.towarID
--WHERE ((Pozycje.ilosc_na_stanie) > 0)
GROUP BY Pozycje.towarID, Towary.kod, Towary.kod2, Towary.nazwa, Towary.pn, Towary.kategoria,
    Pozycje.magazynID,Magazyny.kod
GO


PRINT '### VIEW QTowaryMagazyny ###'
IF (OBJECT_ID('QTowaryMagazyny') IS NULL) EXEC ('CREATE VIEW QTowaryMagazyny AS SELECT * FROM Opcje')
GO
ALTER VIEW QTowaryMagazyny
AS
SELECT     towarID, Towary.kod AS kod_towaru, Towary.kod2 AS kod2_towaru, Towary.nazwa AS nazwa_towaru, Towary.pn, Towary.kategoria,
			Towary.stan_minimalny as stan_minimalny,
		   magazynID, Magazyny.kod AS kod_magazynu
FROM         Towary CROSS JOIN Magazyny
GO






PRINT '### VIEW QStanyKryt ###'
IF (OBJECT_ID('QStanyKryt') IS NULL) EXEC ('CREATE VIEW QStanyKryt AS SELECT * FROM Opcje')
GO
ALTER VIEW QStanyKryt
AS
SELECT Pozycje.towarID,
    Towary.kod AS kod_towaru, Towary.kod2 AS kod2_towaru, Towary.nazwa AS nazwa_towaru, Towary.pn, Towary.kategoria,
    SUM(Pozycje.ilosc_na_stanie) AS ilosc_na_stanie_magazynu, 
    Towary.stan_minimalny
FROM Towary LEFT JOIN
    Pozycje ON Towary.towarID = Pozycje.towarID
--WHERE ((Pozycje.ilosc_na_stanie) > 0)
WHERE (Towary.stan_minimalny > 0)
GROUP BY Pozycje.towarID, Pozycje.towarID, Towary.kod, Towary.kod2, Towary.nazwa, Towary.pn, Towary.kategoria,
    Towary.stan_minimalny
HAVING (SUM(Pozycje.ilosc_na_stanie) < Towary.stan_minimalny or SUM(Pozycje.ilosc_na_stanie) is null)
GO


PRINT '### VIEW QStanyKrytMag ###'
IF (OBJECT_ID('QStanyKrytMag') IS NULL) EXEC ('CREATE VIEW QStanyKrytMag AS SELECT * FROM Opcje')
GO
ALTER VIEW QStanyKrytMag
AS
SELECT     SUM(Pozycje.ilosc_na_stanie) AS ilosc_na_stanie_magazynu, QTowaryMagazyny.towarID, QTowaryMagazyny.kod_towaru, QTowaryMagazyny.kod2_towaru, 
                      QTowaryMagazyny.nazwa_towaru, QTowaryMagazyny.pn, QTowaryMagazyny.kategoria, QTowaryMagazyny.stan_minimalny, 
					  QTowaryMagazyny.magazynID, QTowaryMagazyny.kod_magazynu
FROM         QTowaryMagazyny LEFT OUTER JOIN
                      Pozycje ON QTowaryMagazyny.magazynID = Pozycje.magazynID AND QTowaryMagazyny.towarID = Pozycje.towarID
WHERE (QTowaryMagazyny.stan_minimalny > 0)
GROUP BY QTowaryMagazyny.towarID, QTowaryMagazyny.kod_towaru, QTowaryMagazyny.kod2_towaru, QTowaryMagazyny.nazwa_towaru, QTowaryMagazyny.pn, 
                      QTowaryMagazyny.kategoria, QTowaryMagazyny.stan_minimalny, QTowaryMagazyny.magazynID, QTowaryMagazyny.kod_magazynu
HAVING (SUM(Pozycje.ilosc_na_stanie) < QTowaryMagazyny.stan_minimalny or SUM(Pozycje.ilosc_na_stanie) is null)
GO




PRINT '### Stored Procedures ###'
GO




IF (OBJECT_ID('FnStanyNaDzien') IS NULL) EXEC ('CREATE PROCEDURE FnStanyNaDzien AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE FnStanyNaDzien
	(@data_do datetime, @kod_towaru nvarchar(80)=NULL)
AS
SELECT Pozycjeopis.towarID, Towary.kod AS kod_towaru, 
    Towary.nazwa AS nazwa_towaru, Towary.pn, 
    Towary.kategoria,
    SUM(Operacje.ilosc) AS ilosc_na_stanie_magazynu
FROM Towary RIGHT OUTER JOIN
    Pozycjeopis ON 
    Towary.towarID = Pozycjeopis.towarID LEFT OUTER
     JOIN
    Dokumenty ON 
    Pozycjeopis.dokumentID = Dokumenty.dokumentID LEFT
     OUTER JOIN
    Operacje ON 
    Pozycjeopis.pozycjaopisID = Operacje.pozycjaopisID
WHERE (Dokumenty.data <= @data_do) AND
    (@kod_towaru is null OR Towary.kod LIKE @kod_towaru)
GROUP BY Pozycjeopis.towarID, Towary.kod, 
    Towary.nazwa, Towary.pn, Towary.kategoria
RETURN
GO



IF (OBJECT_ID('FnStanyMagNaDzien') IS NULL) EXEC ('CREATE PROCEDURE FnStanyMagNaDzien AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE FnStanyMagNaDzien
	(@data_do datetime, @kod_magazynu nvarchar(80), @kod_towaru nvarchar(80)=NULL)
AS
SELECT Pozycjeopis.towarID, Towary.kod AS kod_towaru, 
    Towary.nazwa AS nazwa_towaru, Towary.pn, 
    Towary.kategoria,
    Operacje.magazynID, 
    Magazyny.kod AS kod_magazynu, 
    SUM(Operacje.ilosc) AS ilosc_na_stanie_magazynu
FROM Towary RIGHT OUTER JOIN
    Pozycjeopis ON 
    Towary.towarID = Pozycjeopis.towarID RIGHT OUTER JOIN
    Operacje LEFT OUTER JOIN
    Magazyny ON 
    Operacje.magazynID = Magazyny.magazynID ON 
    Pozycjeopis.pozycjaopisID = Operacje.pozycjaopisID LEFT
     OUTER JOIN
    Dokumenty ON 
    Pozycjeopis.dokumentID = Dokumenty.dokumentID
WHERE (Dokumenty.data <= @data_do) AND 
    (Magazyny.kod LIKE @kod_magazynu) AND
    (@kod_towaru is null OR Towary.kod LIKE @kod_towaru)
GROUP BY Pozycjeopis.towarID, Towary.kod, 
    Towary.nazwa, Towary.pn, Towary.kategoria, 
    Operacje.magazynID, Magazyny.kod
RETURN
GO
















PRINT '### Stored Procedures Ex ###'
GO

IF (OBJECT_ID('ZatwierdzDokumentIncPozycje') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentIncPozycje AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentIncPozycje(@recommitmode int,
	@dokumentID int = null, @magazynID int = null, 
	@pozycjaopisID int = null, @towarID int, @ilosc int,
	@pozycjaID int OUTPUT, @ma_sn int)
AS
BEGIN
	declare @ilosc_na_stanie int
	if @pozycjaID is null
	begin
		if @magazynID is null BEGIN RAISERROR ('50029',12,1) return -1 END
		SELECT @pozycjaID = pozycjaID, @ilosc_na_stanie=ilosc_na_stanie FROM Pozycje WHERE pozycjaopisID=@pozycjaopisID AND towarID=@towarID AND magazynID=@magazynID AND ma_sn=@ma_sn
		if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END
	end
	else
	begin
		SELECT @ilosc_na_stanie=ilosc_na_stanie FROM Pozycje WHERE pozycjaID=@pozycjaID
		if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END
	end

	if @pozycjaID is null
	begin
		set @ilosc_na_stanie=0
		INSERT INTO Pozycje(dokumentID, towarID, ilosc_na_stanie, magazynID, pozycjaopisID, ma_sn) VALUES (@dokumentID, @towarID, @ilosc_na_stanie, @magazynID, @pozycjaopisID, @ma_sn)
		if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END
		set @pozycjaID=@@IDENTITY
	end
	if @ilosc_na_stanie+@ilosc>0
	begin
		UPDATE Pozycje SET ilosc_na_stanie=@ilosc_na_stanie+@ilosc WHERE pozycjaID=@pozycjaID
		if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END
	end
	else
	begin
		DELETE FROM Pozycje WHERE pozycjaID=@pozycjaID
		if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END
	end
	return 0
END
GO



IF (OBJECT_ID('ZatwierdzDokumentIncSN') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentIncSN AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentIncSN(@recommitmode int,
	@magazynID int=null, 
	@pozycjaopisID int = null, @towarID int = null,
	@snpozopisID int = null, @sn varchar(50) =null, @ilosc_sn int, 
	@pozycjaID int = null,
	@snpozID int OUTPUT, @powtSN bit)
AS
BEGIN
	declare @na_stanie int
	declare @na_stanie_all_doc int

	--spr. czy jest ju SN na stanie przy zwikszeniu iloci SN (dla zwykych SN nie-serii)
	--if @snpozID is not null AND @ilosc_sn>0
	if @ilosc_sn>0
	begin
		if @powtSN=0
		begin
			if @recommitmode=0 AND @ilosc_sn<>1 BEGIN RAISERROR ('50024',12,1) return -1 END

			SELECT @na_stanie_all_doc=Count(*) FROM QSnpozEx WHERE sn=@sn AND towarID=@towarID
			if @@Error<>0 BEGIN RAISERROR ('500012',12,1) return -1 END
			
			if @recommitmode=0 AND @na_stanie_all_doc>0 BEGIN RAISERROR ('50020',12,1) return -1 END
		end
	end

	if @snpozID is null
	begin
		if @snpozopisID is null BEGIN RAISERROR ('blad wew',12,1) return -1 END
		SELECT @snpozID=snpozID, @na_stanie=na_stanie FROM QSnpozEx WHERE snpozopisID=@snpozopisID AND magazynID=@magazynID
		if @@Error<>0 BEGIN RAISERROR ('500012',12,1) return -1 END
	end
	else
	begin
		SELECT @na_stanie=na_stanie FROM Snpoz WHERE snpozID=@snpozID
		if @@Error<>0 BEGIN RAISERROR ('500012',12,1) return -1 END
	end

	if @snpozID is null
	begin
		set @na_stanie=0
		INSERT INTO Snpoz(pozycjaID,sn,na_stanie,snpozopisID) VALUES (@pozycjaID,@sn,@na_stanie,@snpozopisID)
		if @@Error<>0 BEGIN RAISERROR ('500012',12,1) return -1 END
		set @snpozID=@@IDENTITY
	end
	if @na_stanie+@ilosc_sn>0
	begin
		UPDATE Snpoz SET na_stanie=@na_stanie+@ilosc_sn WHERE snpozID=@snpozID
		if @@Error<>0 BEGIN RAISERROR ('500012',12,1) return -1 END
	end
	else
	begin
		DELETE FROM Snpoz WHERE snpozID=@snpozID
		if @@Error<>0 BEGIN RAISERROR ('500012',12,1) return -1 END
	end
	return 0
END
GO




IF (OBJECT_ID('ZatwierdzDokumentIncOperacje') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentIncOperacje AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentIncOperacje(@recommitmode int,
	@magazynID int, 
	@pozycjaopisID int, @towarID int, @ilosc int,
	@pozycjaopis_zrodlowaID int,
	@operacjaID int OUTPUT)
AS
BEGIN
	if @magazynID is null BEGIN RAISERROR ('50029',12,1) return -1 END

	declare @ilosc_op int
	set @ilosc_op=null
	SELECT @operacjaID=operacjaID, @ilosc_op=ilosc FROM Operacje WHERE pozycjaopisID=@pozycjaopisID AND pozycjaopis_zrodlowaID=@pozycjaopis_zrodlowaID AND magazynID=@magazynID
	if @@Error<>0 BEGIN RAISERROR ('500014',12,1) return -1 END


	if @operacjaID is null
	begin
		set @ilosc_op=0
		INSERT INTO Operacje(ilosc, magazynID, pozycjaopisID, pozycjaopis_zrodlowaID) VALUES (@ilosc_op, @magazynID, @pozycjaopisID, @pozycjaopis_zrodlowaID)
		if @@Error<>0 BEGIN RAISERROR ('500014',12,1) return -1 END
		set @operacjaID=@@IDENTITY
	end
	UPDATE Operacje SET ilosc=@ilosc_op+@ilosc WHERE operacjaID=@operacjaID
	if @@Error<>0 BEGIN RAISERROR ('500014',12,1) return -1 END
	return 0
END
GO



IF (OBJECT_ID('ZatwierdzDokumentSNPZ') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentSNPZ AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentSNPZ(@recommitmode int,
	@dokumentID int, @magazynID int, 
	@pozycjaopisID int, @towarID int, @ilosc int,
	@snpozopisID int, @sn varchar(50), @powtSN bit, @komplet int)
AS
BEGIN
	if @komplet is not null BEGIN RAISERROR ('50036',12,1) return -1 end

	declare @rv int
	declare @pozycjaID int
	set @pozycjaID=null
	execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
		@dokumentID, @magazynID, 
		@pozycjaopisID, @towarID, @ilosc,
		@pozycjaID OUTPUT, 1
	if @rv=-1 or @rv is null return -1

	declare @snpozID int
	set @snpozID=null
	execute @rv=ZatwierdzDokumentIncSN @recommitmode,
		@magazynID, 
		@pozycjaopisID, @towarID,
		@snpozopisID, @sn, @ilosc, 
		@pozycjaID,
		@snpozID OUTPUT, @powtSN
	if @rv=-1  or @rv is null return -1

	declare @operacjaID int
	set @operacjaID = null
	execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
		@magazynID, 
		@pozycjaopisID, @towarID, @ilosc,
		@pozycjaopisID,
		@operacjaID OUTPUT
	if @rv=-1  or @rv is null return -1
	return 0
END
GO

IF (OBJECT_ID('ZatwierdzDokumentSNWZ') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentSNWZ AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentSNWZ(@recommitmode int,
	@dokumentID int, @magazyn_zrodlowyID int, 
	@pozycjaopisID int, @towarID int, @ilosc int,
	@snpozopisID int, @sn varchar(50), @powtSN bit, @komplet int)
AS
BEGIN
	--return 0
	declare @rv int
	declare @ilosc_tmp int
	declare @ilosc_do_zdjecia int, @ilosc_do_zdjecia_m int
	declare @snpoz_zrodlowyID int, @na_stanie int
	declare @pozycjaopis_zrodlowaID int
	declare @pozycja_zrodlowaID int
	declare @dokument_zrodlowyID int

	if @komplet is not null BEGIN RAISERROR ('50036',12,1) return -1 end

	set @ilosc_tmp=@ilosc
	DECLARE cSnpoz CURSOR STATIC LOCAL FOR SELECT dokumentID, pozycjaID, snpozID, pozycjaopisID, na_stanie FROM QSnpozEx WHERE sn=@sn AND towarID=@towarID AND magazynID=@magazyn_zrodlowyID ORDER BY snpozID
	--DECLARE cSnpoz CURSOR STATIC LOCAL FOR SELECT dokumentID, pozycjaID, snpozID, pozycjaopisID, na_stanie FROM QSnpozEx WHERE sn=@sn AND towarID=@towarID AND magazynID=@magazyn_zrodlowyID ORDER BY dokumentID
	--DECLARE cSnpoz CURSOR STATIC LOCAL FOR SELECT Snpoz.pozycjaID, snpozID, pozycjaopisID, na_stanie FROM Snpoz INNER JOIN Pozycje ON Snpoz.pozycjaID = Pozycje.pozycjaID WHERE sn=@sn AND towarID=@towarID AND magazynID=@magazyn_zrodlowyID

	if @@Error<>0 BEGIN RAISERROR ('50030',12,1) return -1 END
	OPEN cSnpoz 
	if @@Error<>0 BEGIN RAISERROR ('50012',12,1) return -1 END

	FETCH NEXT FROM cSnpoz INTO @dokument_zrodlowyID, @pozycja_zrodlowaID, @snpoz_zrodlowyID, @pozycjaopis_zrodlowaID, @na_stanie
	--FETCH NEXT FROM cSnpoz INTO @pozycja_zrodlowaID, @snpoz_zrodlowyID, @pozycjaopis_zrodlowaID, @na_stanie

	if @@Error<>0 BEGIN RAISERROR ('50012',12,1) return -1 END
	WHILE @@FETCH_STATUS = 0
	BEGIN
		if @ilosc_tmp>0
		begin
			set @ilosc_do_zdjecia=@na_stanie
			if @ilosc_do_zdjecia>@ilosc_tmp
				set @ilosc_do_zdjecia=@ilosc_tmp
			set @ilosc_do_zdjecia_m=-@ilosc_do_zdjecia




			execute @rv=ZatwierdzDokumentIncSN @recommitmode,
				null, 
				null, null,
				null, null, @ilosc_do_zdjecia_m, 
				null,
				@snpoz_zrodlowyID OUTPUT, @powtSN
			if @rv=-1 or @rv is null begin CLOSE cSnpoz DEALLOCATE cSnpoz return -1 end


			
			execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
				null, null, 
				null, null, @ilosc_do_zdjecia_m,
				@pozycja_zrodlowaID, null
			if @rv=-1 or @rv is null begin CLOSE cSnpoz DEALLOCATE cSnpoz return -1 end
		


	
			declare @operacjaID int
			set @operacjaID=null
			execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
				@magazyn_zrodlowyID, 
				@pozycjaopisID, @towarID, @ilosc_do_zdjecia_m,
				@pozycjaopis_zrodlowaID,
				@operacjaID OUTPUT
			if @rv=-1 or @rv is null begin CLOSE cSnpoz DEALLOCATE cSnpoz return -1 end

			set @ilosc_tmp=@ilosc_tmp-@ilosc_do_zdjecia
		end
		else
		begin
			break
		end

		FETCH NEXT FROM cSnpoz INTO @dokument_zrodlowyID, @pozycja_zrodlowaID, @snpoz_zrodlowyID, @pozycjaopis_zrodlowaID, @na_stanie
		--FETCH NEXT FROM cSnpoz INTO @pozycja_zrodlowaID, @snpoz_zrodlowyID, @pozycjaopis_zrodlowaID, @na_stanie

		if @@Error<>0 BEGIN  CLOSE cSnpoz DEALLOCATE cSnpoz RAISERROR ('50012',12,1) return -1 END
	end

	if @ilosc_tmp>0
	BEGIN
		if @powtSN =0 BEGIN CLOSE cSnpoz DEALLOCATE cSnpoz RAISERROR ('50027',12,1) return -1 END
		if @powtSN<>0 BEGIN CLOSE cSnpoz DEALLOCATE cSnpoz RAISERROR ('50028',12,1) return -1 END
	END


	CLOSE cSnpoz
	DEALLOCATE cSnpoz

	return 0
END
GO



IF (OBJECT_ID('ZatwierdzDokumentSNMM') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentSNMM AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentSNMM(@recommitmode int,
	@dokumentID int, @magazyn_zrodlowyID int, @magazynID int, 
	@pozycjaopisID int, @towarID int, @ilosc int,
	@snpozopisID int, @sn varchar(50), @powtSN bit, @komplet int)
AS
BEGIN
	declare @rv int
	declare @ilosc_tmp int
	declare @ilosc_do_przes int, @ilosc_do_przes_m int
	declare @snpoz_zrodlowyID int, @snpozopis_zrodlowyID int, @na_stanie int
	declare @pozycjaopis_zrodlowaID int
	declare @pozycja_zrodlowaID int
	declare @dokument_zrodlowyID int

	if @komplet is not null BEGIN RAISERROR ('50036',12,1) return -1 end

	--declare @snpozopis_docelowyID int, @ilosc_docelowa_max int, @ilosc_docelowa_na_stanie int
	--declare @pozycjaopis_docelowaID int
	--declare @dokument_docelowyID int
	if @magazynID is null BEGIN RAISERROR ('50029',12,1) return -1 END
	if @magazyn_zrodlowyID is null BEGIN RAISERROR ('50029',12,1) return -1 END
	if @magazyn_zrodlowyID=@magazynID BEGIN RAISERROR ('50021',12,1) return -1 END

	set @ilosc_tmp=@ilosc
	DECLARE cSnpoz CURSOR STATIC LOCAL FOR SELECT dokumentID, pozycjaID, snpozID, pozycjaopisID, snpozopisID, na_stanie FROM QSnpozEx WHERE sn=@sn AND towarID=@towarID AND magazynID=@magazyn_zrodlowyID ORDER BY snpozID
	--DECLARE cSnpoz CURSOR STATIC LOCAL FOR SELECT dokumentID, pozycjaID, snpozID, pozycjaopisID, snpozopisID, na_stanie FROM QSnpozEx WHERE sn=@sn AND towarID=@towarID AND magazynID=@magazyn_zrodlowyID ORDER BY dokumentID
	--DECLARE cSnpoz CURSOR STATIC LOCAL FOR SELECT Pozycje.dokumentID, Snpoz.pozycjaID, snpozID, pozycjaopisID, snpozopisID, na_stanie FROM Snpoz INNER JOIN Pozycje ON Snpoz.pozycjaID=Pozycje.pozycjaID INNER JOIN Dokumenty ON Pozycje.dokumentID=Dokumenty.dokumentID WHERE sn=@sn AND towarID=@towarID AND Pozycje.magazynID=@magazyn_zrodlowyID ORDER BY snpozID

	if @@Error<>0 BEGIN RAISERROR ('50030',12,1) return -1 END
	OPEN cSnpoz 
	if @@Error<>0 BEGIN RAISERROR ('50012',12,1) return -1 END
	FETCH NEXT FROM cSnpoz INTO @dokument_zrodlowyID, @pozycja_zrodlowaID, @snpoz_zrodlowyID, @pozycjaopis_zrodlowaID, @snpozopis_zrodlowyID, @na_stanie
	if @@Error<>0 BEGIN RAISERROR ('50012',12,1) return -1 END
	WHILE @@FETCH_STATUS = 0
	BEGIN
		if @ilosc_tmp>0
		begin
			set @ilosc_do_przes=@na_stanie
			if @ilosc_do_przes>@ilosc_tmp set @ilosc_do_przes=@ilosc_tmp
			set @ilosc_do_przes_m=-@ilosc_do_przes

			execute @rv=ZatwierdzDokumentIncSN @recommitmode,
				null, 
				null, null,
				null, null, @ilosc_do_przes_m, 
				null,
				@snpoz_zrodlowyID OUTPUT, @powtSN
			if @rv=-1 or @rv is null begin CLOSE cSnpoz DEALLOCATE cSnpoz return -1 end
			execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
				@magazyn_zrodlowyID, null, 
				null, null, @ilosc_do_przes_m,
				@pozycja_zrodlowaID, 1
			if @rv=-1 or @rv is null begin CLOSE cSnpoz DEALLOCATE cSnpoz return -1 end



			declare @pozycjaID int
			set @pozycjaID=null
			execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
				@dokument_zrodlowyID, @magazynID,
				@pozycjaopis_zrodlowaID, @towarID, @ilosc_do_przes,
				@pozycjaID OUTPUT, 1
			if @rv=-1 or @rv is null begin CLOSE cSnpoz DEALLOCATE cSnpoz return -1 end

			declare @snpozID int
			set @snpozID=null
			execute @rv=ZatwierdzDokumentIncSN @recommitmode,
				@magazynID, 
				@pozycjaopis_zrodlowaID, @towarID,
				@snpozopis_zrodlowyID, @sn, @ilosc_do_przes, 
				@pozycjaID,
				@snpozID OUTPUT, @powtSN
			if @rv=-1 or @rv is null begin CLOSE cSnpoz DEALLOCATE cSnpoz return -1 end
	
			declare @operacjaID int
			set @operacjaID=null
			execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
				@magazyn_zrodlowyID, 
				@pozycjaopisID, @towarID, @ilosc_do_przes_m,
				@pozycjaopis_zrodlowaID,
				@operacjaID OUTPUT
			if @rv=-1 or @rv is null begin CLOSE cSnpoz DEALLOCATE cSnpoz return -1 end

			set @operacjaID=null
			execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
				@magazynID, 
				@pozycjaopisID, @towarID, @ilosc_do_przes,
				@pozycjaopis_zrodlowaID,
				@operacjaID OUTPUT
			if @rv=-1 or @rv is null begin CLOSE cSnpoz DEALLOCATE cSnpoz return -1 end


			set @ilosc_tmp=@ilosc_tmp-@ilosc_do_przes
		end
		else
		begin
			break
		end
		FETCH NEXT FROM cSnpoz INTO @dokument_zrodlowyID, @pozycja_zrodlowaID, @snpoz_zrodlowyID, @pozycjaopis_zrodlowaID, @snpozopis_zrodlowyID, @na_stanie
		if @@Error<>0 BEGIN  CLOSE cSnpoz DEALLOCATE cSnpoz RAISERROR ('50012',12,1) return -1 END
	end
	if @ilosc_tmp>0 
	BEGIN
		if @powtSN =0 BEGIN CLOSE cSnpoz DEALLOCATE cSnpoz RAISERROR ('50027',12,1) return -1 END
		if @powtSN<>0 BEGIN CLOSE cSnpoz DEALLOCATE cSnpoz RAISERROR ('50028',12,1) return -1 END
	END

	CLOSE cSnpoz
	DEALLOCATE cSnpoz

	return 0
END
GO

IF (OBJECT_ID('ZatwierdzDokumentSNZK') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentSNZK AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentSNZK(@recommitmode int,
	@dokumentID int, @dokument_zrodlowyID int, @magazynID int, 
	@pozycjaopisID int, @towarID int, @ilosc int,
	@snpozopisID int, @sn varchar(50), @powtSN bit, @komplet int)
AS
BEGIN

	declare @rv int
	declare @ilosc_tmp int
	declare @ilosc_do_przyjecia int
	declare @snpozopis_docelowyID int, @ilosc_docelowa_max int, @ilosc_docelowa_na_stanie int
	declare @pozycjaopis_docelowaID int
	declare @dokument_docelowyID int

	if @komplet is not null BEGIN RAISERROR ('50036',12,1) return -1 end

	if @dokument_zrodlowyID is null BEGIN RAISERROR ('50018',12,1) return -1 END
	declare @zatwierdzony_zrodlowy int, @bezstanowy smallint
	SELECT @zatwierdzony_zrodlowy=zatwierdzony, @bezstanowy=bezstanowy FROM Dokumenty WHERE dokumentID=@dokument_zrodlowyID
	if @@Error<>0 BEGIN RAISERROR ('50010',12,1) return -1 END
	if @zatwierdzony_zrodlowy=0 BEGIN RAISERROR ('50023',12,1) return -1 END
	if @bezstanowy<>0 BEGIN RAISERROR ('50038',12,1) return -1 END

	set @ilosc_tmp=@ilosc

	--DECLARE cSnpozopis CURSOR STATIC LOCAL FOR SELECT dokumentID, pozycjaopisID, snpozopisID, ilosc FROM QSnpozopisEx
	--WHERE snod=@sn AND pozycjaopisID IN (SELECT pozycjaopis_zrodlowaID FROM QOperacje WHERE dokumentID=@dokument_zrodlowyID AND towarID=@towarID)
	--ORDER BY pozycjaopisID

	DECLARE cSnpozopis CURSOR STATIC LOCAL FOR SELECT QSnpozopisEx.dokumentID, QSnpozopisEx.pozycjaopisID, QSnpozopisEx.snpozopisID, QSnpozopisEx.ilosc FROM QSnpozopisEx INNER JOIN QOperacje ON QOperacje.pozycjaopis_zrodlowaID=QSnpozopisEx.pozycjaopisID AND
		QOperacje.dokumentID=@dokument_zrodlowyID AND QSnpozopisEx.towarID=@towarID AND QSnpozopisEx.snod=@sn


	if @@Error<>0 BEGIN RAISERROR ('50030',12,1) return -1 END
	OPEN cSnpozopis 
	if @@Error<>0 BEGIN RAISERROR ('50012',12,1) return -1 END
	FETCH NEXT FROM cSnpozopis INTO @dokument_docelowyID, @pozycjaopis_docelowaID, @snpozopis_docelowyID, @ilosc_docelowa_max
	if @@Error<>0 BEGIN RAISERROR ('50012',12,1) return -1 END

	WHILE @@FETCH_STATUS = 0
	BEGIN
		if @ilosc_tmp>0
		begin


			SELECT @ilosc_docelowa_na_stanie=sum(na_stanie) FROM Snpoz WHERE snpozopisID=@snpozopis_docelowyID
			if @@Error<>0 BEGIN RAISERROR ('50012',12,1) return -1 END

			set @ilosc_do_przyjecia=@ilosc_tmp
			if @ilosc_do_przyjecia>@ilosc_docelowa_max-@ilosc_docelowa_na_stanie
				set @ilosc_do_przyjecia=@ilosc_docelowa_max-@ilosc_docelowa_na_stanie

			declare @pozycjaID int
			set @pozycjaID=null
			execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
				@dokument_docelowyID, @magazynID, 
				@pozycjaopis_docelowaID, @towarID, @ilosc_do_przyjecia,
				@pozycjaID OUTPUT, 1
			if @rv=-1 or @rv is null begin CLOSE cSnpozopis DEALLOCATE cSnpozopis return -1 end


			declare @snpozID int
			set @snpozID=null
			execute @rv=ZatwierdzDokumentIncSN @recommitmode,
				@magazynID, 
				@pozycjaopis_docelowaID, @towarID,
				@snpozopis_docelowyID, @sn, @ilosc_do_przyjecia, 
				@pozycjaID,
				@snpozID OUTPUT, @powtSN
			if @rv=-1 or @rv is null begin CLOSE cSnpozopis DEALLOCATE cSnpozopis return -1 end


			declare @operacjaID int
			set @operacjaID=null
			execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
				@magazynID, 
				@pozycjaopisID, @towarID, @ilosc_do_przyjecia,
				@pozycjaopis_docelowaID,
				@operacjaID OUTPUT
			if @rv=-1 or @rv is null begin CLOSE cSnpozopis DEALLOCATE cSnpozopis return -1 end

			set @ilosc_tmp=@ilosc_tmp-@ilosc_do_przyjecia
		end
		else
		begin
			break
		end
		FETCH NEXT FROM cSnpozopis INTO @dokument_docelowyID, @pozycjaopis_docelowaID, @snpozopis_docelowyID, @ilosc_docelowa_max
		if @@Error<>0 BEGIN CLOSE cSnpozopis DEALLOCATE cSnpozopis RAISERROR ('50012',12,1) return -1 END
	end

	if @ilosc_tmp>0 BEGIN CLOSE cSnpozopis DEALLOCATE cSnpozopis RAISERROR ('50017',12,1) return -1 END

	CLOSE cSnpozopis DEALLOCATE cSnpozopis
	return 0
END


GO

IF (OBJECT_ID('ZatwierdzDokumentSNZD') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentSNZD AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentSNZD(@recommitmode int,
	@dokumentID int, @dokument_zrodlowyID int, @magazyn_zrodlowyID int, 
	@pozycjaopisID int, @towarID int, @ilosc int,
	@snpozopisID int, @sn varchar(50), @powtSN bit, @komplet int)
AS
BEGIN
	declare @rv int
	declare @pozycjaopis_docelowaID int
	declare @snpozopis_docelowyID int
	declare @pozycja_docelowaID int
	declare @snpoz_docelowyID int
	declare @ilosc_m int

	if @komplet is not null BEGIN RAISERROR ('50036',12,1) return -1 end

	if @dokument_zrodlowyID is null BEGIN RAISERROR ('50018',12,1) return -1 END
	declare @zatwierdzony_zrodlowy int, @bezstanowy smallint
	SELECT @zatwierdzony_zrodlowy=zatwierdzony, @bezstanowy=bezstanowy FROM Dokumenty WHERE dokumentID=@dokument_zrodlowyID
	if @@Error<>0 BEGIN RAISERROR ('50010',12,1) return -1 END
	if @zatwierdzony_zrodlowy=0 BEGIN RAISERROR ('50023',12,1) return -1 END
	if @bezstanowy<>0 BEGIN RAISERROR ('50038',12,1) return -1 END


	SELECT @pozycjaopis_docelowaID=pozycjaopisID, @snpozopis_docelowyID=snpozopisID, @pozycja_docelowaID=pozycjaID, @snpoz_docelowyID=snpozID
		FROM QSnpozEx WHERE dokumentID=@dokument_zrodlowyID AND sn=@sn AND towarID=@towarID AND magazynID=@magazyn_zrodlowyID
	if @@Error<>0 BEGIN RAISERROR ('50012',12,1) return -1 END

	if @snpoz_docelowyID is null
	BEGIN
		if @powtSN =0 BEGIN RAISERROR ('50027',12,1) return -1 END
		if @powtSN<>0 BEGIN RAISERROR ('50028',12,1) return -1 END
	END

	set @ilosc_m=-@ilosc

	execute @rv=ZatwierdzDokumentIncSN @recommitmode,
		null, 
		null, null,
		null, null, @ilosc_m, 
		null,
		@snpoz_docelowyID OUTPUT, @powtSN
	if @rv=-1 or @rv is null return -1

	execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
		null, null, 
		null, null, @ilosc_m,
		@pozycja_docelowaID, null
	if @rv=-1 or @rv is null return -1

	declare @operacjaID int
	set @operacjaID=null
	execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
		@magazyn_zrodlowyID, 
		@pozycjaopisID, @towarID, @ilosc_m,
		@pozycjaopis_docelowaID,
		@operacjaID OUTPUT
	if @rv=-1 or @rv is null return -1

	return 0
END
GO


IF (OBJECT_ID('ZatwierdzDokumentSNKM') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentSNKM AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentSNKM(@recommitmode int,
	@dokumentID int, @magazyn_zrodlowyID int, @magazynID int, 
	@pozycjaopisID int, @towarID int, @ilosc int,
	@snpozopisID int, @sn varchar(50), @powtSN bit, @komplet int)
AS
BEGIN
	declare @rv int

	if @komplet=1
	begin
		execute @rv=ZatwierdzDokumentSNPZ @recommitmode,
			@dokumentID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, null
		if @rv=-1 or @rv is null return -1
		return 0
	end
	if @komplet=0
	begin
		execute @rv=ZatwierdzDokumentSNWZ @recommitmode,
			@dokumentID, @magazyn_zrodlowyID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, null
		if @rv=-1 or @rv is null return -1
		return 0
	end
	return -1
END
GO
IF (OBJECT_ID('ZatwierdzDokumentSNDK') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentSNDK AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentSNDK(@recommitmode int,
	@dokumentID int, @magazyn_zrodlowyID int, @magazynID int, 
	@pozycjaopisID int, @towarID int, @ilosc int,
	@snpozopisID int, @sn varchar(50), @powtSN bit, @komplet int)
AS
BEGIN
	declare @rv int
	if @komplet=0
	begin
		execute @rv=ZatwierdzDokumentSNPZ @recommitmode,
			@dokumentID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, null
		if @rv=-1 or @rv is null return -1
		return 0
	end
	if @komplet=1
	begin
		execute @rv=ZatwierdzDokumentSNWZ @recommitmode,
			@dokumentID, @magazyn_zrodlowyID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, null
		if @rv=-1 or @rv is null return -1
		return 0
	end
	return -1
END
GO


IF (OBJECT_ID('ZatwierdzDokumentSN') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentSN AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentSN(@recommitmode int,
	@dokumentID int, @dokument_zrodlowyID int, @typ nvarchar(50),
	@magazynID int, @magazyn_bezstanowy smallint,
	@magazyn_zrodlowyID int, @magazyn_zrodl_bezstanowy smallint,
	@pozycjaopisID int, @towarID int, @ilosc int,
	@snpozopisID int, @sn varchar(50), @powtSN bit, @komplet int)
AS
BEGIN
	DECLARE @rv int
	if @typ='PZ'
	begin
		if @magazyn_bezstanowy <> 0
			return 0
		else
		begin
			execute @rv=ZatwierdzDokumentSNPZ @recommitmode,
				@dokumentID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='WZ'
	begin
		if @magazyn_zrodl_bezstanowy <> 0
			return 0
		else
		begin
			execute @rv=ZatwierdzDokumentSNWZ @recommitmode,
				@dokumentID, @magazyn_zrodlowyID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='ZK'
	begin
		if @magazyn_bezstanowy <> 0
			BEGIN RAISERROR ('50039',12,1) return -1 end
		else
		begin
			execute @rv=ZatwierdzDokumentSNZK @recommitmode,
				@dokumentID, @dokument_zrodlowyID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='ZD'
	begin
		if @magazyn_zrodl_bezstanowy <> 0
			BEGIN RAISERROR ('50039',12,1) return -1 end
		else
		begin
			execute @rv=ZatwierdzDokumentSNZD @recommitmode,
				@dokumentID, @dokument_zrodlowyID, @magazyn_zrodlowyID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='MM'
	begin
		if @magazyn_bezstanowy <> 0 and @magazyn_zrodl_bezstanowy <> 0
			return 0
		else if @magazyn_bezstanowy <> 0
		begin
			-- WZ like
			execute @rv=ZatwierdzDokumentSNWZ @recommitmode,
				@dokumentID, @magazyn_zrodlowyID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, @komplet
			if @rv=-1 or @rv is null return -1
			return 0

		end
		else if @magazyn_zrodl_bezstanowy <> 0
		begin
			-- PZ like
			execute @rv=ZatwierdzDokumentSNPZ @recommitmode,
				@dokumentID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, @komplet
			if @rv=-1 or @rv is null return -1
			return 0		
		end
		else
		begin
			-- Real MM
			execute @rv=ZatwierdzDokumentSNMM @recommitmode,
				@dokumentID, @magazyn_zrodlowyID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='KM'
	begin
		if @magazyn_bezstanowy <> 0 or @magazyn_zrodl_bezstanowy <> 0
			BEGIN RAISERROR ('50039',12,1) return -1 end
		else
		begin
			execute @rv=ZatwierdzDokumentSNKM @recommitmode,
				@dokumentID, @magazyn_zrodlowyID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='DK'
	begin
		if @magazyn_bezstanowy <> 0 or @magazyn_zrodl_bezstanowy <> 0
			BEGIN RAISERROR ('50039',12,1) return -1 end
		else
		begin
			execute @rv=ZatwierdzDokumentSNDK @recommitmode,
				@dokumentID, @magazyn_zrodlowyID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @snpozopisID, @sn, @powtSN, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end

	BEGIN RAISERROR ('50008',12,1) return -1 END
END

GO
IF (OBJECT_ID('ZatwierdzDokumentPozPZ') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentPozPZ AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentPozPZ(@recommitmode int,
	@dokumentID int, @magazynID int, 
	@pozycjaopisID int, @towarID int, @ilosc int, @komplet int)
AS
BEGIN
	if @ilosc is null or @ilosc=0 BEGIN RAISERROR ('50009',12,1) return -1 end
	if @komplet is not null BEGIN RAISERROR ('50036',12,1) return -1 end

	declare @rv int
	declare @pozycjaID int
	set @pozycjaID=null
	execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
		@dokumentID, @magazynID, 
		@pozycjaopisID, @towarID, @ilosc,
		@pozycjaID OUTPUT, 0
	if @rv=-1 or @rv is null return -1

	declare @operacjaID int
	set @operacjaID=null
	execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
		@magazynID, 
		@pozycjaopisID, @towarID, @ilosc,
		@pozycjaopisID,
		@operacjaID OUTPUT
	if @rv=-1 or @rv is null return -1
	return 0
END

GO
IF (OBJECT_ID('ZatwierdzDokumentPozWZ') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentPozWZ AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentPozWZ(@recommitmode int,
	@dokumentID int, @magazyn_zrodlowyID int, 
	@pozycjaopisID int, @towarID int, @ilosc int, @komplet int)
AS
BEGIN
	declare @rv int
	declare @ilosc_tmp int
	declare @ilosc_do_zdjecia int, @ilosc_do_zdjecia_m int
	declare @na_stanie int
	declare @pozycjaopis_zrodlowaID int
	declare @pozycja_zrodlowaID int
	declare @dokument_zrodlowyID int

	if @ilosc is null or @ilosc=0 BEGIN RAISERROR ('50009',12,1) return -1 end
	if @komplet is not null BEGIN RAISERROR ('50036',12,1) return -1 end

	set @ilosc_tmp=@ilosc
	DECLARE cPozycje CURSOR STATIC LOCAL FOR SELECT dokumentID, pozycjaID, pozycjaopisID, ilosc_na_stanie FROM QPozycjeEx WHERE towarID=@towarID AND magazynID=@magazyn_zrodlowyID And ma_sn=0 ORDER BY pozycjaID
	if @@Error<>0 BEGIN RAISERROR ('50030',12,1) return -1 END
	OPEN cPozycje 
	if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END
	FETCH NEXT FROM cPozycje INTO @dokument_zrodlowyID, @pozycja_zrodlowaID, @pozycjaopis_zrodlowaID, @na_stanie
	if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END
	WHILE @@FETCH_STATUS = 0
	BEGIN
		if @ilosc_tmp>0
		begin
			set @ilosc_do_zdjecia=@na_stanie
			if @ilosc_do_zdjecia>@ilosc_tmp
				set @ilosc_do_zdjecia=@ilosc_tmp
			set @ilosc_do_zdjecia_m=-@ilosc_do_zdjecia

			execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
				null, null, 
				null, null, @ilosc_do_zdjecia_m,
				@pozycja_zrodlowaID, null
			if @rv=-1 or @rv is null begin CLOSE cPozycje DEALLOCATE cPozycje return -1 end
		

			declare @operacjaID int
			set @operacjaID=null
			execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
				@magazyn_zrodlowyID, 
				@pozycjaopisID, @towarID, @ilosc_do_zdjecia_m,
				@pozycjaopis_zrodlowaID,
				@operacjaID OUTPUT
			if @rv=-1 or @rv is null begin CLOSE cPozycje DEALLOCATE cPozycje return -1 end

			set @ilosc_tmp=@ilosc_tmp-@ilosc_do_zdjecia
		end
		else
		begin
			break
		end
		FETCH NEXT FROM cPozycje INTO @dokument_zrodlowyID, @pozycja_zrodlowaID, @pozycjaopis_zrodlowaID, @na_stanie
		if @@Error<>0 BEGIN CLOSE cPozycje DEALLOCATE cPozycje RAISERROR ('50011',12,1) return -1 END
	end
	if @ilosc_tmp>0 BEGIN CLOSE cPozycje DEALLOCATE cPozycje RAISERROR ('50016',12,1) return -1 END
	CLOSE cPozycje
	DEALLOCATE cPozycje

	return 0
END

GO
IF (OBJECT_ID('ZatwierdzDokumentPozMM') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentPozMM AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentPozMM(@recommitmode int,
	@dokumentID int, @magazyn_zrodlowyID int, @magazynID int, 
	@pozycjaopisID int, @towarID int, @ilosc int, @komplet int)
AS
BEGIN
	declare @rv int
	declare @ilosc_tmp int
	declare @ilosc_do_przes int, @ilosc_do_przes_m int
	declare @na_stanie int
	declare @pozycjaopis_zrodlowaID int
	declare @pozycja_zrodlowaID int
	declare @dokument_zrodlowyID int

	if @ilosc is null or @ilosc=0 BEGIN RAISERROR ('50009',12,1) return -1 end
	if @komplet is not null BEGIN RAISERROR ('50036',12,1) return -1 end

	if @magazyn_zrodlowyID=@magazynID BEGIN RAISERROR ('50021',12,1) return -1 END

	set @ilosc_tmp=@ilosc
	DECLARE cPozycje CURSOR STATIC LOCAL FOR SELECT dokumentID, pozycjaID, pozycjaopisID, ilosc_na_stanie FROM QPozycjeEx WHERE towarID=@towarID AND magazynID=@magazyn_zrodlowyID And ma_sn=0 ORDER BY pozycjaID
	if @@Error<>0 BEGIN RAISERROR ('50030',12,1) return -1 END
	OPEN cPozycje
	if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END
	FETCH NEXT FROM cPozycje INTO @dokument_zrodlowyID, @pozycja_zrodlowaID, @pozycjaopis_zrodlowaID, @na_stanie
	if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END
	WHILE @@FETCH_STATUS = 0
	BEGIN
		if @ilosc_tmp>0
		begin
			set @ilosc_do_przes=@na_stanie
			if @ilosc_do_przes>@ilosc_tmp set @ilosc_do_przes=@ilosc_tmp
			set @ilosc_do_przes_m=-@ilosc_do_przes

			execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
				@magazyn_zrodlowyID, null, 
				null, null, @ilosc_do_przes_m,
				@pozycja_zrodlowaID, 0
			if @rv=-1 or @rv is null begin CLOSE cPozycje DEALLOCATE cPozycje return -1 end

			declare @pozycjaID int
			set @pozycjaID=null
			execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
				@dokument_zrodlowyID, @magazynID,
				@pozycjaopis_zrodlowaID, @towarID, @ilosc_do_przes,
				@pozycjaID OUTPUT, 0
			if @rv=-1 or @rv is null begin CLOSE cPozycje DEALLOCATE cPozycje return -1 end
		

			declare @operacjaID int
			set @operacjaID=null
			execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
				@magazyn_zrodlowyID, 
				@pozycjaopisID, @towarID, @ilosc_do_przes_m,
				@pozycjaopis_zrodlowaID,
				@operacjaID OUTPUT
			if @rv=-1 or @rv is null begin CLOSE cPozycje DEALLOCATE cPozycje return -1 end

			set @operacjaID=null
			execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
				@magazynID, 
				@pozycjaopisID, @towarID, @ilosc_do_przes,
				@pozycjaopis_zrodlowaID,
				@operacjaID OUTPUT
			if @rv=-1 or @rv is null begin CLOSE cPozycje DEALLOCATE cPozycje return -1 end


			set @ilosc_tmp=@ilosc_tmp-@ilosc_do_przes
		end
		else
		begin
			break
		end
		FETCH NEXT FROM cPozycje INTO @dokument_zrodlowyID, @pozycja_zrodlowaID, @pozycjaopis_zrodlowaID, @na_stanie
		if @@Error<>0 BEGIN CLOSE cPozycje DEALLOCATE cPozycje RAISERROR ('50011',12,1) return -1 END
	end
	if @ilosc_tmp>0 BEGIN CLOSE cPozycje DEALLOCATE cPozycje RAISERROR ('50016',12,1) return -1 END
	CLOSE cPozycje
	DEALLOCATE cPozycje

	return 0
END

GO
IF (OBJECT_ID('ZatwierdzDokumentPozZK') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentPozZK AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentPozZK(@recommitmode int,
	@dokumentID int, @dokument_zrodlowyID int, @magazynID int, 
	@pozycjaopisID int, @towarID int, @ilosc int, @komplet int)
AS
BEGIN

	declare @rv int
	declare @ilosc_tmp int
	declare @ilosc_do_przyjecia int
	declare @snpozopis_docelowyID int, @ilosc_docelowa_max int, @ilosc_docelowa_na_stanie int
	declare @pozycjaopis_docelowaID int
	declare @dokument_docelowyID int

	if @ilosc is null or @ilosc=0 BEGIN RAISERROR ('50009',12,1) return -1 end
	if @komplet is not null BEGIN RAISERROR ('50036',12,1) return -1 end

	if @dokument_zrodlowyID is null BEGIN RAISERROR ('50018',12,1) return -1 END
	declare @zatwierdzony_zrodlowy int, @bezstanowy smallint
	SELECT @zatwierdzony_zrodlowy=zatwierdzony, @bezstanowy=bezstanowy FROM Dokumenty WHERE dokumentID=@dokument_zrodlowyID
	if @@Error<>0 BEGIN RAISERROR ('50010',12,1) return -1 END
	if @zatwierdzony_zrodlowy=0 BEGIN RAISERROR ('50023',12,1) return -1 END
	if @bezstanowy<>0 BEGIN RAISERROR ('50038',12,1) return -1 END

	set @ilosc_tmp=@ilosc




	--DECLARE cPozycjeopis CURSOR STATIC LOCAL FOR SELECT dokumentID, pozycjaopisID, ilosc FROM QPozycjeopisEx
	--WHERE pozycjaopisID IN (SELECT pozycjaopis_zrodlowaID FROM QOperacje WHERE dokumentID=@dokument_zrodlowyID AND towarID=@towarID)
	--ORDER BY pozycjaopisID

	DECLARE cPozycjeopis CURSOR STATIC LOCAL FOR SELECT QPozycjeopisEx.dokumentID, QPozycjeopisEx.pozycjaopisID, QPozycjeopisEx.ilosc FROM QPozycjeopisEx INNER JOIN QOperacje ON QOperacje.pozycjaopis_zrodlowaID=QPozycjeopisEx.pozycjaopisID AND
		QOperacje.dokumentID=@dokument_zrodlowyID AND QPozycjeopisEx.towarID=@towarID

	if @@Error<>0 BEGIN RAISERROR ('50030',12,1) return -1 END
	OPEN cPozycjeopis 
	if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END
	FETCH NEXT FROM cPozycjeopis INTO @dokument_docelowyID, @pozycjaopis_docelowaID, @ilosc_docelowa_max
	if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END

	WHILE @@FETCH_STATUS = 0
	BEGIN
		if @ilosc_tmp>0
		begin

			--SELECT @ilosc_docelowa_na_stanie=sum(na_stanie) FROM Snpoz WHERE snpozopisID=@snpozopis_docelowyID
			SELECT @ilosc_docelowa_na_stanie = ilosc_na_stanie FROM Pozycje WHERE pozycjaopisID=@pozycjaopis_docelowaID
			if @@Error<>0 BEGIN RAISERROR ('50012',12,1) return -1 END

			set @ilosc_do_przyjecia=@ilosc_tmp
			if @ilosc_do_przyjecia>@ilosc_docelowa_max-@ilosc_docelowa_na_stanie
				set @ilosc_do_przyjecia=@ilosc_docelowa_max-@ilosc_docelowa_na_stanie

			declare @pozycjaID int
			set @pozycjaID=null
			execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
				@dokument_docelowyID, @magazynID, 
				@pozycjaopis_docelowaID, @towarID, @ilosc_do_przyjecia,
				@pozycjaID OUTPUT, 0
			if @rv=-1 or @rv is null begin CLOSE cSnpozopis DEALLOCATE cSnpozopis return -1 end


			declare @operacjaID int
			set @operacjaID=null
			execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
				@magazynID, 
				@pozycjaopisID, @towarID, @ilosc_do_przyjecia,
				@pozycjaopis_docelowaID,
				@operacjaID OUTPUT
			if @rv=-1 or @rv is null begin CLOSE cSnpozopis DEALLOCATE cSnpozopis return -1 end

			set @ilosc_tmp=@ilosc_tmp-@ilosc_do_przyjecia
		end
		else
		begin
			break
		end
		FETCH NEXT FROM cPozycjeopis INTO @dokument_docelowyID, @pozycjaopis_docelowaID, @ilosc_docelowa_max
		if @@Error<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis RAISERROR ('50011',12,1) return -1 END
	end



	if @ilosc_tmp>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis RAISERROR ('50017',12,1) return -1 END



	CLOSE cPozycjeopis DEALLOCATE cPozycjeopis
	return 0
END

GO
IF (OBJECT_ID('ZatwierdzDokumentPozZD') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentPozZD AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentPozZD(@recommitmode int,
	@dokumentID int, @dokument_zrodlowyID int, @magazyn_zrodlowyID int, 
	@pozycjaopisID int, @towarID int, @ilosc int, @komplet int)
AS
BEGIN
	declare @rv int
	declare @pozycjaopis_docelowaID int
	declare @pozycja_docelowaID int
	declare @ilosc_m int

	if @ilosc is null or @ilosc=0 BEGIN RAISERROR ('50009',12,1) return -1 end
	if @komplet is not null BEGIN RAISERROR ('50036',12,1) return -1 end

	if @dokument_zrodlowyID is null BEGIN RAISERROR ('50018',12,1) return -1 END
	declare @zatwierdzony_zrodlowy int, @bezstanowy smallint
	SELECT @zatwierdzony_zrodlowy=zatwierdzony, @bezstanowy=bezstanowy FROM Dokumenty WHERE dokumentID=@dokument_zrodlowyID
	if @@Error<>0 BEGIN RAISERROR ('50010',12,1) return -1 END
	if @zatwierdzony_zrodlowy=0 BEGIN RAISERROR ('50023',12,1) return -1 END
	if @bezstanowy<>0 BEGIN RAISERROR ('50038',12,1) return -1 END


	SELECT @pozycjaopis_docelowaID=pozycjaopisID, @pozycja_docelowaID=pozycjaID
		FROM QPozycjeEx WHERE dokumentID=@dokument_zrodlowyID AND towarID=@towarID AND magazynID=@magazyn_zrodlowyID
	if @@Error<>0 BEGIN RAISERROR ('50011',12,1) return -1 END
	if @pozycja_docelowaID is null BEGIN RAISERROR ('50016',12,1) return -1 END

	set @ilosc_m=-@ilosc

	execute @rv=ZatwierdzDokumentIncPozycje @recommitmode,
		null, null, 
		null, null, @ilosc_m,
		@pozycja_docelowaID, null
	if @rv=-1 or @rv is null return -1

	declare @operacjaID int
	set @operacjaID=null
	execute @rv=ZatwierdzDokumentIncOperacje @recommitmode,
		@magazyn_zrodlowyID, 
		@pozycjaopisID, @towarID, @ilosc_m,
		@pozycjaopis_docelowaID,
		@operacjaID OUTPUT
	if @rv=-1 or @rv is null return -1

	return 0
END
GO

IF (OBJECT_ID('ZatwierdzDokumentPozKM') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentPozKM AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentPozKM(@recommitmode int,
	@dokumentID int, @magazyn_zrodlowyID int, @magazynID int, 
	@pozycjaopisID int, @towarID int, @ilosc int, @komplet int)
AS
BEGIN
	declare @rv int

	if @komplet=1
	begin
		execute @rv=ZatwierdzDokumentPozPZ @recommitmode,
			@dokumentID, @magazynID, @pozycjaopisID, @towarID, @ilosc, null
		if @rv=-1 or @rv is null return -1
		return 0
	end
	if @komplet=0
	begin
		execute @rv=ZatwierdzDokumentPozWZ @recommitmode,
			@dokumentID, @magazyn_zrodlowyID, @pozycjaopisID, @towarID, @ilosc, null
		if @rv=-1 or @rv is null return -1
		return 0
	end

	return -1
END
GO
IF (OBJECT_ID('ZatwierdzDokumentPozDK') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentPozDK AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentPozDK(@recommitmode int,
	@dokumentID int, @magazyn_zrodlowyID int, @magazynID int, 
	@pozycjaopisID int, @towarID int, @ilosc int, @komplet int)
AS
BEGIN
	declare @rv int

	if @komplet=0
	begin
		execute @rv=ZatwierdzDokumentPozPZ @recommitmode,
			@dokumentID, @magazynID, @pozycjaopisID, @towarID, @ilosc, null
		if @rv=-1 or @rv is null return -1
		return 0
	end
	if @komplet=1
	begin
		execute @rv=ZatwierdzDokumentPozWZ @recommitmode,
			@dokumentID, @magazyn_zrodlowyID, @pozycjaopisID, @towarID, @ilosc, null
		if @rv=-1 or @rv is null return -1
		return 0
	end

	return -1
END
GO




IF (OBJECT_ID('ZatwierdzDokumentPoz') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokumentPoz AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokumentPoz(@recommitmode int,
	@dokumentID int, @dokument_zrodlowyID int, @typ nvarchar(50), 
	@magazynID int, @magazyn_bezstanowy smallint, 
	@magazyn_zrodlowyID int, @magazyn_zrodl_bezstanowy smallint,
	@pozycjaopisID int, @towarID int, @ilosc int, @komplet int)
AS
BEGIN



	DECLARE @rv int
	if @typ='PZ'
	begin
		if @magazyn_bezstanowy <> 0
			return 0
		else
		begin
			execute @rv=ZatwierdzDokumentPozPZ @recommitmode,
				@dokumentID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='WZ'
	begin
		if @magazyn_zrodl_bezstanowy <> 0
			return 0
		else
		begin
			execute @rv=ZatwierdzDokumentPozWZ @recommitmode,
				@dokumentID, @magazyn_zrodlowyID, @pozycjaopisID, @towarID, @ilosc, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='ZK'
	begin
		if @magazyn_bezstanowy <> 0
			BEGIN RAISERROR ('50039',12,1) return -1 end
		else
		begin
			execute @rv=ZatwierdzDokumentPozZK @recommitmode,
				@dokumentID, @dokument_zrodlowyID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='ZD'
	begin
		if @magazyn_zrodl_bezstanowy <> 0
			BEGIN RAISERROR ('50039',12,1) return -1 end
		else
		begin
			execute @rv=ZatwierdzDokumentPozZD @recommitmode,
				@dokumentID, @dokument_zrodlowyID, @magazyn_zrodlowyID, @pozycjaopisID, @towarID, @ilosc, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='MM'
	begin
		if @magazyn_bezstanowy <> 0 and @magazyn_zrodl_bezstanowy <> 0
			return 0
		else if @magazyn_bezstanowy <> 0
		begin
			-- WZ like
			execute @rv=ZatwierdzDokumentPozWZ @recommitmode,
				@dokumentID, @magazyn_zrodlowyID, @pozycjaopisID, @towarID, @ilosc, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
		else if @magazyn_zrodl_bezstanowy <> 0
		begin
			-- PZ like
			execute @rv=ZatwierdzDokumentPozPZ @recommitmode,
				@dokumentID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @komplet
			if @rv=-1 or @rv is null return -1
			return 0			
		end
		else
		begin
			-- Real MM
			execute @rv=ZatwierdzDokumentPozMM @recommitmode,
				@dokumentID, @magazyn_zrodlowyID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='KM'
	begin
		if @magazyn_bezstanowy <> 0 or @magazyn_zrodl_bezstanowy <> 0
			BEGIN RAISERROR ('50039',12,1) return -1 end
		else
		begin
			execute @rv=ZatwierdzDokumentPozKM @recommitmode,
				@dokumentID, @magazyn_zrodlowyID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end
	if @typ='DK'
	begin
		if @magazyn_bezstanowy <> 0 or @magazyn_zrodl_bezstanowy <> 0
			BEGIN RAISERROR ('50039',12,1) return -1 end
		else
		begin
			execute @rv=ZatwierdzDokumentPozDK @recommitmode,
				@dokumentID, @magazyn_zrodlowyID, @magazynID, @pozycjaopisID, @towarID, @ilosc, @komplet
			if @rv=-1 or @rv is null return -1
			return 0
		end
	end

	BEGIN RAISERROR ('50008',12,1) return -1 END
END



GO
IF (OBJECT_ID('ZatwierdzDokument') IS NULL) EXEC ('CREATE PROCEDURE ZatwierdzDokument AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE ZatwierdzDokument (@recommitmode int, @dokumentID int, @uzytkownikID int, @checkonly int, @withouttrans int)
AS
BEGIN
	SET NOCOUNT ON

	IF @withouttrans is null set @withouttrans=0


	DECLARE @TranName nvarchar(50)
	set @TranName='ZatwierdzDokument'
	IF @withouttrans=0
	BEGIN
		BEGIN TRANSACTION @TranName
		if @@Error<>0 BEGIN RAISERROR ('50031',12,1) return -1 END
	END

	declare @tmp int
	SELECT @tmp=pozycjaID FROM Pozycje WITH (READCOMMITTED) WHERE 1=0
	SELECT @tmp=snpozID FROM Snpoz WITH (READCOMMITTED) WHERE 1=0
	SELECT @tmp=operacjaID FROM Operacje WITH (READCOMMITTED) WHERE 1=0
	SELECT @tmp=dokumentID FROM Dokumenty WITH (READCOMMITTED) WHERE 1=0



	-- ustaw ma_sn w Pozycjeopis
	DECLARE @rv INT
	UPDATE Pozycjeopis SET ma_sn=1 FROM Pozycjeopis WHERE dokumentID=@dokumentID AND (SELECT Count(*) FROM Snpozopis WHERE Snpozopis.pozycjaopisID=Pozycjeopis.pozycjaopisID)>0
	if @@Error<>0 BEGIN IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50011',12,1) return -1 END



	
	--otwrz kursor dla dokumentw
	DECLARE @zatwierdzony smallint, @typ nvarchar(50), @magazynID int, @magazyn_bezstanowy smallint, @magazyn_zrodlowyID int, @magazyn_zrodl_bezstanowy smallint, @dokument_zrodlowyID int, @bezstanowy smallint
	DECLARE cDokumenty CURSOR STATIC LOCAL FOR SELECT zatwierdzony, typ, magazynID, magazyn_bezstanowy, magazyn_zrodlowyID, magazyn_zrodl_bezstanowy, dokument_zrodlowyID, bezstanowy FROM QDokumenty WHERE dokumentID=@dokumentID
	if @@Error<>0 BEGIN IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50030',12,1) return -1 END
	OPEN cDokumenty
	if @@Error<>0 BEGIN IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50010',12,1) return -1 END
	FETCH NEXT FROM cDokumenty INTO @zatwierdzony, @typ, @magazynID, @magazyn_bezstanowy, @magazyn_zrodlowyID, @magazyn_zrodl_bezstanowy, @dokument_zrodlowyID, @bezstanowy
	if @@Error<>0 BEGIN CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50010',12,1) return -1 END
	if @zatwierdzony<>0 BEGIN IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50013',12,1)  return -1 END
		
	WHILE @@FETCH_STATUS = 0
	BEGIN
		--otwrz kursor dla pozycji
		DECLARE @pozycjaopisID int, @towarID int, @ilosc int, @ilosc_zwer int, @ma_sn bit, @komplet int, @ilosc_elem int, @ilosc_komp int
		DECLARE cPozycjeopis CURSOR STATIC LOCAL FOR SELECT pozycjaopisID, towarID, ilosc, ilosc_zwer, ma_sn, komplet FROM Pozycjeopis WHERE dokumentID=@dokumentID
		if @@Error<>0 BEGIN CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50030',12,1) return -1 END
		OPEN cPozycjeopis
		if @@Error<>0 BEGIN CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50011',12,1) return -1 END
		FETCH NEXT FROM cPozycjeopis INTO @pozycjaopisID, @towarID, @ilosc, @ilosc_zwer, @ma_sn, @komplet
		if @@Error<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50011',12,1) return -1 END
		if @@FETCH_STATUS <> 0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50026',12,1) return -1 END
		
		

		WHILE @@FETCH_STATUS = 0
		BEGIN
			SELECT @ilosc_elem=sum(ilosc) FROM Elementy WHERE pozopisID=@pozycjaopisID
			SELECT @ilosc_komp=sum(ilosc) FROM Komplety WHERE pozopisID=@pozycjaopisID
	
			if @komplet=0 and (@ilosc_elem=0 or @ilosc_elem is null) BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50034',12,1) return -1 END
			if @komplet=0 and @ilosc_komp<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50033',12,1) return -1 END
			if @komplet=1 and (@ilosc_komp=0 or @ilosc_komp is null) BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50034',12,1) return -1 END
			if @komplet=1 and @ilosc_elem<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50033',12,1) return -1 END
			if @komplet is null and (@ilosc_elem<>0 or @ilosc_komp<>0) BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50035',12,1) return -1 END
	
	
			-- sprawd lub ustaw ilo pozycji zgodnie z ilosci elementw
			if @komplet=1
			begin
				if @ilosc is null
				begin
					UPDATE Pozycjeopis SET ilosc=@ilosc_komp WHERE pozycjaopisID=@pozycjaopisID
					if @@Error<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('500011',12,1) return -1 END
					set @ilosc=@ilosc_komp
				end
				else
				begin
					if @ilosc_komp<>@ilosc BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50037',12,1) return -1 END
				end
			end
			if @komplet=0
			begin
				if @ilosc is null
				begin
					UPDATE Pozycjeopis SET ilosc=@ilosc_elem WHERE pozycjaopisID=@pozycjaopisID
					if @@Error<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('500011',12,1) return -1 END
					set @ilosc=@ilosc_elem
				end
				else
				begin
					if @ilosc_elem<>@ilosc BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50037',12,1) return -1 END
				end
			end
	
			if @ilosc=0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50009',12,1) return -1 END
	



			--stwrz tekst miejsca bdu
			Declare @nazwa_towaru nvarchar(50)
			Declare @powtSN bit
			Declare @wymaganeSN bit
			SELECT @nazwa_towaru=nazwa, @powtSN=powtSN, @wymaganeSN=wymaganeSN FROM Towary WHERE towarID=@towarID
			if @@Error<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50032',12,1) return -1 END
			Declare @errpoz nvarchar(200)
			set @errpoz='<pozycja> '''+@nazwa_towaru+''''
			
			-- sprawd czy ilo jest zgodna z iloci zweryfikowan
			if @ilosc_zwer is not null
			BEGIN
				if @ilosc_zwer<>@ilosc BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50040 %s',12,1,@errpoz) return -1 END
			END
			
			IF @ma_sn<>0
			BEGIN
				--ma_sn
				
				-- sprawd lub ustaw ilo pozycji zgodnie z podanymi numerami seryjnymi
				DECLARE @sum_ilosc_sn int
				SELECT @sum_ilosc_sn=sum(ilosc_sn) FROM Snpozopis WHERE pozycjaopisID=@pozycjaopisID
				if @@Error<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50011 %s',12,1,@errpoz) return -1 END
				if @ilosc is null
				begin
					UPDATE Pozycjeopis SET ilosc=@sum_ilosc_sn WHERE pozycjaopisID=@pozycjaopisID
					if @@Error<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('500011 %s',12,1,@errpoz) return -1 END
				end
				else
				begin
					if @sum_ilosc_sn<>@ilosc BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50004 %s',12,1,@errpoz) return -1 END
				end
				
				--otwrz kursor dla snpozopis
				DECLARE @snpozopisID int, @snod nvarchar(50), @ilosc_sn int
				DECLARE cSnpozopis CURSOR STATIC LOCAL FOR SELECT snpozopisID, snod, ilosc_sn FROM Snpozopis WHERE pozycjaopisID=@pozycjaopisID
				if @@Error<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50030 %s',12,1,@errpoz) return -1 END
				OPEN cSnpozopis
				if @@Error<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50012 %s',12,1,@errpoz) return -1 END
				FETCH NEXT FROM cSnpozopis INTO @snpozopisID, @snod, @ilosc_sn
				if @@Error<>0 BEGIN CLOSE cSnpozopis DEALLOCATE cSnpozopis CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50012 %s',12,1,@errpoz) return -1 END

				WHILE @@FETCH_STATUS = 0
				BEGIN
					--sprawdz czy wypelniona ilosc_sn
					if @ilosc_sn is null or @ilosc_sn<=0 BEGIN CLOSE cSnpozopis DEALLOCATE cSnpozopis CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50006 %s',12,1,@errpoz) return -1 END

					--sprawdz czy wypelnione sn
					--if @snod is null BEGIN CLOSE cSnpozopis DEALLOCATE cSnpozopis CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50005 %s',12,1,@errpoz) return -1 END
					if @snod is null BEGIN CLOSE cSnpozopis DEALLOCATE cSnpozopis CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50005 %s',12,1,@errpoz) return -1 END
					if len(@snod)=0 BEGIN CLOSE cSnpozopis DEALLOCATE cSnpozopis CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50005 %s',12,1,@errpoz) return -1 END


					--stwrz tekst miejsca bdu
					Declare @errpozsn varchar(200)
					set @errpozsn='<pozycja> '''+@nazwa_towaru+''''+', <sn> '''+@snod+''''

					if @bezstanowy=0
					BEGIN
						execute @rv=ZatwierdzDokumentSN @recommitmode,
							@dokumentID, @dokument_zrodlowyID, @typ, @magazynID, @magazyn_bezstanowy, @magazyn_zrodlowyID, @magazyn_zrodl_bezstanowy, @pozycjaopisID, @towarID, @ilosc_sn, @snpozopisID, @snod, @powtSN, @komplet
						if @rv<>0 or @rv is null BEGIN CLOSE cSnpozopis DEALLOCATE cSnpozopis CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50019 %s',12,1,@errpozsn) return -1 end
					END
				
					FETCH NEXT FROM cSnpozopis INTO @snpozopisID, @snod, @ilosc_sn
					if @@Error<>0 BEGIN CLOSE cSnpozopis DEALLOCATE cSnpozopis CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50012 %s',12,1,@errpoz) return -1 END
				END
				close cSnpozopis
				DEALLOCATE cSnpozopis
			END
			ELSE
			BEGIN
				if @wymaganeSN<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50025 %s',12,1,@errpoz) return -1 end
				if @bezstanowy=0
				BEGIN
					execute @rv=ZatwierdzDokumentPoz @recommitmode,
						@dokumentID, @dokument_zrodlowyID, @typ, @magazynID, @magazyn_bezstanowy, @magazyn_zrodlowyID, @magazyn_zrodl_bezstanowy, @pozycjaopisID, @towarID, @ilosc, @komplet
					if @rv<>0 or @rv is null BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50022 %s',12,1,@errpoz) return -1 end
				END
			END
			FETCH NEXT FROM cPozycjeopis INTO @pozycjaopisID, @towarID, @ilosc, @ilosc_zwer, @ma_sn, @komplet
			if @@Error<>0 BEGIN CLOSE cPozycjeopis DEALLOCATE cPozycjeopis CLOSE cDokumenty DEALLOCATE cDokumenty IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50011',12,1) return -1 END
		END
	
		FETCH NEXT FROM cDokumenty INTO @zatwierdzony, @typ, @magazynID, @magazyn_bezstanowy, @magazyn_zrodlowyID, @magazyn_zrodl_bezstanowy, @dokument_zrodlowyID, @bezstanowy
		if @@Error<>0 BEGIN IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50012',12,1) return -1 END
		CLOSE cPozycjeopis DEALLOCATE cPozycjeopis
	END
	CLOSE cDokumenty DEALLOCATE cDokumenty

	if @recommitmode<>0
	BEGIN
		UPDATE Dokumenty SET zatwierdzony=1, uzytkownikID=COALESCE(uzytkownikID, @uzytkownikID), data_zatwierdzenia=COALESCE(data_zatwierdzenia, getdate()) WHERE dokumentID=@dokumentID
		if @@Error<>0 BEGIN IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50012',12,1) return -1 END
	END
	ELSE
	BEGIN
		UPDATE Dokumenty SET zatwierdzony=1, uzytkownikID=@uzytkownikID, data_zatwierdzenia=getdate() WHERE dokumentID=@dokumentID
		if @@Error<>0 BEGIN IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50012',12,1) return -1 END
	END


	if @Checkonly is not null and @Checkonly<>0
	BEGIN
		IF @withouttrans=0 IF @withouttrans=0 ROLLBACK TRANSACTION @TranName
		if @@Error<>0 BEGIN IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50015',12,1) return -1 END
	END
	ELSE
	BEGIN
		IF @withouttrans=0 COMMIT TRANSACTION @TranName
		if @@Error<>0 BEGIN IF @withouttrans=0 ROLLBACK TRANSACTION @TranName RAISERROR ('50015',12,1) return -1 END
	END
	return 0
END

GO










IF (OBJECT_ID('GetNextDocumentNumberSub') IS NULL) EXEC ('CREATE PROCEDURE GetNextDocumentNumberSub AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE GetNextDocumentNumberSub(@entryNR nvarchar(50), @entryDATE nvarchar(50), @newdoc nvarchar(50) OUTPUT)
AS
BEGIN
	SET NOCOUNT ON
	declare @lastdocnr int
	declare @lastdocdate nvarchar(50)
	declare @newdocnr int
	declare @newdocdate nvarchar(50)
	declare @curdate datetime
	declare @iyear int
	declare @imonth int
	declare @iday int
	declare @syear nvarchar(50)
	declare @smonth nvarchar(50)
	declare @sday nvarchar(50)

	DECLARE @TranName nvarchar(50)
	set @TranName='GetNextDocumentNumberSub'
	BEGIN TRANSACTION @TranName

	SELECT @lastdocnr=wartosc FROM Opcje WHERE nazwa=@entryNR and uzytkownikID is null
	if @@Error<>0 BEGIN ROLLBACK TRANSACTION @TranName RAISERROR ('50012',12,1) return -1 END
	SELECT @lastdocdate=wartosc FROM Opcje WHERE nazwa=@entryDATE and uzytkownikID is null
	if @@Error<>0 BEGIN ROLLBACK TRANSACTION @TranName RAISERROR ('50012',12,1) return -1 END

	set @curdate=GETDATE()
	set @iyear=Datepart(yyyy,@curdate)
	set @imonth=Datepart(mm,@curdate)
	set @iday=Datepart(dd,@curdate)
	set @syear=CAST(@iyear as varchar(50))
	set @smonth=CAST(@imonth as varchar(50))
	set @sday=CAST(@iday as varchar(50))
	if (@imonth<10) set @smonth='0'+@smonth
	if (@iday<10) set @sday='0'+@sday
	set @newdocdate = @syear+'/'+@smonth+'/'+@sday

	if not @lastdocnr is null and not @lastdocdate is null
	begin
		if @lastdocdate=@newdocdate set @newdocnr=@lastdocnr+1
		else set @newdocnr=1
	end
	else
		set @newdocnr=1

	set @newdoc=@newdocdate+'/'+CAST(@newdocnr as nvarchar (50))

	if @lastdocnr is null
	begin
		INSERT INTO Opcje(nazwa, wartosc, uzytkownikID) values(@entryDATE,@newdocdate,null)
		if @@Error<>0 BEGIN ROLLBACK TRANSACTION @TranName RAISERROR ('500011',12,1) return -1 END
		INSERT INTO Opcje(nazwa, wartosc, uzytkownikID) values(@entryNR,@newdocnr,null)
		if @@Error<>0 BEGIN ROLLBACK TRANSACTION @TranName RAISERROR ('500011',12,1) return -1 END
	end
	else
	begin
		UPDATE Opcje Set wartosc=@newdocdate WHERE nazwa=@entryDATE AND uzytkownikID is null
		if @@Error<>0 BEGIN ROLLBACK TRANSACTION @TranName RAISERROR ('500011',12,1) return -1 END
		UPDATE Opcje Set wartosc=@newdocnr WHERE nazwa=@entryNR AND uzytkownikID is null
		if @@Error<>0 BEGIN ROLLBACK TRANSACTION @TranName RAISERROR ('500011',12,1) return -1 END
	end

	COMMIT TRANSACTION @TranName
	if @@Error<>0 BEGIN ROLLBACK TRANSACTION @TranName RAISERROR ('50015',12,1) return -1 END

	return 0
END
GO

IF (OBJECT_ID('GetNextDocumentNumber') IS NULL) EXEC ('CREATE PROCEDURE GetNextDocumentNumber AS SELECT * FROM Opcje')
GO
ALTER PROCEDURE GetNextDocumentNumber
AS
BEGIN
	SET NOCOUNT ON
	declare @newdoc nvarchar(50) 
	declare @rv int
	Execute @rv=GetNextDocumentNumberSub 'LastDocNR', 'LastDocDATE', @newdoc OUTPUT

	if @rv=-1 or @rv is null
		SELECT	null as numer
	else
		SELECT @newdoc as numer
END
GO

--IF (OBJECT_ID('GetNextImportNumber') IS NULL) EXEC ('CREATE PROCEDURE GetNextImportNumber AS SELECT * FROM Opcje')
--GO
--ALTER PROCEDURE GetNextImportNumber
--AS
--BEGIN
--	SET NOCOUNT ON
--	declare @newdoc nvarchar(50) 
--	declare @rv int
--	Execute @rv=GetNextDocumentNumberSub 'LastEImpNR', 'LastEImpDATE', @newdoc OUTPUT

--	if @rv=-1 or @rv is null
--		SELECT	null as numer
--	else
--		SELECT @newdoc as numer
--END
--GO











SET NOCOUNT ON
execute SetBaseVersion 1.46
GO

PRINT '### END ###'
GO

